//*****************************************************************************
//*
//*
//*		CalcGenerator.h
//*
//*
//*****************************************************************************
//
//	So geht es:
//
//		int _cdecl GetToken(void *pParam,const char *pText,double *pValue,unsigned *pVarNumber)
//		{
//			if(*pText=='X'){*pVarNumber=0;*pValue=22.0;return 1;}
//			if(*pText=='Y'){*pVarNumber=1;*pValue=33.0;return 1;}
//			return 0;
//		}
//
//		void main()
//		{
//			double			aValues[3]={22,33,44};		// X,Y,Z
//			double			dResult;
//			char		   *pError;
//			CalcGenData		sData;
//
//			CalcInit    (&sData,3,GetToken);
//			CalcGenerate(&sData,"X+Y*2-Z",&pError);
//
//			for(i=0;i<8;i++)
//				{
//					aValues[0] = (i&1)? 33.3:22.2;
//					aValues[1] = (i&2)? 22.2:44.4;
//					aValues[2] = (i&3)? 11.1:22.2;
//
//					CalcSetValues(&sData,aValues,3);
//					dResult = CalcExecute(&sData);
//
//					printf("%f = %f+%f*2+%z\n",dResult,aValues[0],aValues[1],aValues[2]);
//				}
//
#ifndef		__CALCGENERATOR_H__
#define 	__CALCGENERATOR_H__


typedef	unsigned short	CalcAction;
typedef int (_cdecl *TokenCb)(void *pParam,const char *pText, double *pValue,unsigned *pVarNumber);

class CalcGenData
{
public:

	CalcGenData();
   ~CalcGenData();

	const char	   *pErrorPos;					// Zeiger auf Fehlerposition
	void		   *pParam;						// Parameter fr Tokenfunktion
	TokenCb			pProc;						// Callback fr Token
	double		   *pValues;					// Array mit Werten
	unsigned		uValueCnt;					// Anzahl der Werte
	unsigned		uValueMax;					// Gre des Werte-Arrays
	CalcAction	   *pActions;					// Array mit Befehlen
	unsigned		uActionCnt;					// Anzahl der Befehle
	unsigned		uActionMax;					// Gre des Befehles-Arrays
	unsigned		uCmpValue;					// Alles

};

int 	CalcChangeVars(CalcGenData *pData,unsigned uVar1,unsigned uVar2);
double  CalcExecute   (CalcGenData *pData,int *pOk=0);
void	CalcInit      (CalcGenData *pData,int iVars,TokenCb pProc,void *pParam=0);
void	CalcCopy      (CalcGenData *pData,CalcGenData *pNew);
int 	CalcDependency(CalcGenData *pData,void *pBits,unsigned uMax,int iClear=1);
int		CalcGenerate  (CalcGenData *pData,const char *pEquation,const char **pErrorPos);
void	CalcCompress  (CalcGenData *pData,const unsigned char *pConstList,unsigned uSize);
void	CalcSetValues (CalcGenData *pData,const double *pValues,unsigned uCount);
void	CalcPrint     (CalcGenData *pData);
void	CalcExit      (CalcGenData *pData);
#define CalcIsNan     (dVal)	((((unsigned*)(&(dVal)))[1]&0x7FFF0000)>=0x7FF00000)



#endif
