//*****************************************************************************
//*
//*
//*		InfoDlg.cpp: Implementierungsdatei
//*
//*
//*****************************************************************************
//
//	Copyright  2006	Anton Zechner
//
#include	"StdAfx.h"
#include	"MathViewer.h"
#include	"InfoDlg.h"


#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char  THIS_FILE[] = __FILE__;
#endif


BEGIN_MESSAGE_MAP(CInfoDlg, CDialog)
	//{{AFX_MSG_MAP(CInfoDlg)
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CRect	CInfoDlg::m_sLastRect(0,0,0,0);
HICON	CInfoDlg::m_hIcon=0;

//*****************************************************************************
//*
//*		Dialogfeld CInfoDlg
//*
//*****************************************************************************
CInfoDlg::CInfoDlg(CWnd *pParent) : CDialog(CInfoDlg::IDD,pParent)
{
	//{{AFX_DATA_INIT(CInfoDlg)
	//}}AFX_DATA_INIT
}



//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CInfoDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CInfoDlg)
	//}}AFX_DATA_MAP
}



//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
// Behandlungsroutinen fr Nachrichten CInfoDlg
BOOL CInfoDlg::OnInitDialog()
{
CRect	sRect;
BYTE	bBuffer[1024];
int		i,iPos,iLen;


	SetWndData(this,IDD);						// Help ID einsetllen

	if(!m_hIcon)
		{
		m_hIcon=LoadIcon(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDR_MAINFRAME));
		}

	SetIcon(m_hIcon,0);
	SetIcon(m_hIcon,1);

	if(m_sLastRect.Width())MoveWindow(m_sLastRect,FALSE);

	CDialog::OnInitDialog();

	GetClientRect(&sRect);

	m_cTextWnd.Create(WS_VISIBLE|WS_VSCROLL|LBS_NOTIFY|LBS_NOINTEGRALHEIGHT,sRect,this);
	m_cTextWnd.SetColor( 4,RGB(  0,  0,  0));
	m_cTextWnd.SetColor( 5,RGB(  0,  0,128));
	m_cTextWnd.SetColor( 6,RGB(  0,128,  0));
	m_cTextWnd.SetColor( 7,RGB(  0,128,128));
	m_cTextWnd.SetColor( 8,RGB(128,  0,  0));
	m_cTextWnd.SetColor( 9,RGB(128,  0,128));
	m_cTextWnd.SetColor(10,RGB(128,128,  0));
	m_cTextWnd.SetColor(11,RGB(128,128,128));
	m_cTextWnd.SetColor(12,RGB(192,192,192));
	m_cTextWnd.SetColor(13,RGB(  0,  0,255));
	m_cTextWnd.SetColor(14,RGB(  0,255,  0));
	m_cTextWnd.SetColor(15,RGB(  0,255,255));
	m_cTextWnd.SetColor(16,RGB(255,  0,  0));
	m_cTextWnd.SetColor(17,RGB(255,  0,255));
	m_cTextWnd.SetColor(18,RGB(255,255,  0));
	m_cTextWnd.SetColor(19,RGB(255,128,128));


	m_cTextWnd.SetFont (NULL);
	m_cTextWnd.SetMarkType(2);
	m_cTextWnd.SetMarkMode(0);


	for(iPos=0;iPos<m_iInfoLen;iPos+=iLen)
		{
		for(iLen=0;iPos+iLen<m_iInfoLen;iLen++)
			{
			if(iLen>=sizeof(bBuffer))break;
			if(m_pInfoText[iPos+iLen]=='\r')break;
			if(m_pInfoText[iPos+iLen]=='\n')break;
			}

		memcpy(bBuffer,m_pInfoColor+iPos,iLen);
		for(i=0;i<iLen;i++)bBuffer[i]+=4;

		m_cTextWnd.AddString(m_pInfoText+iPos,bBuffer,iLen);

		if(iPos+iLen<m_iInfoLen && m_pInfoText[iPos+iLen]=='\r')iLen++;
		if(iPos+iLen<m_iInfoLen && m_pInfoText[iPos+iLen]=='\n')iLen++;
		}



return TRUE;
}


//*****************************************************************************
//*
//*		OnSize
//*
//*****************************************************************************
void CInfoDlg::OnSize(UINT nType,int iSizeX,int iSizeY)
{

	if(IsWindow(m_cTextWnd.m_hWnd))
	if(iSizeX && iSizeY)
		{
		CRect	sRect(0,0,iSizeX,iSizeY);
		m_cTextWnd.MoveWindow(&sRect,FALSE);
		m_cTextWnd.RedrawWindow(NULL,NULL,RDW_INVALIDATE|RDW_UPDATENOW|RDW_ERASE|RDW_ALLCHILDREN|RDW_UPDATENOW|RDW_FRAME);
		}

}

//*****************************************************************************
//*
//*		SetText
//*
//*****************************************************************************
//	Den Anzeige Text einstellen
//	pText	: Zeiger auf den Text
//	pColor	: Zeiger auf Farben
//	iLen	: Lnge des Textes, wenn -1 wird die Lnge mit strlen bestimmt
void CInfoDlg::SetText(char *pText,void *pColor,int iLen)
{

	m_pInfoText  = pText;
	m_pInfoColor = (unsigned char*)pColor;
	m_iInfoLen   = (iLen<0)? strlen(pText):iLen;

}


//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void CInfoDlg::OnOK()
{
	GetWindowRect(&m_sLastRect);
	CDialog::OnOK();
}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void CInfoDlg::OnCancel()
{
	GetWindowRect(&m_sLastRect);
	CDialog::OnCancel();
}
