//*****************************************************************************
//*
//*
//*		MathViewerDlg.cpp
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"MathViewer.h"
#include	"MathViewerDlg.h"
#include	"CalcGenerator.h"
#include	"OptionenDlg.h"
#include	"PictureDlg.h"
#include	"RegConfig.h"
#include	"D3Utility.h"
#include	"InfoDlg.h"


#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

#define 	 LOG_DRAW		0
#define 	 ID_SHOWEQU		0x5600
#define 	 IDC_LIST		0x5601
#define 	 IDC_PAINT		0x5602
#define 	 ID_EQUTICK		0x5603
#define 	 ID_REDRAW		0x5604
#define 	 ID_VALUE_CHG	0x5605
#define 	 ID_DEMO2D		0x5610
#define 	 ID_DEMO3D		0x5620
#define 	 ID_SHOWHLP		0x5630
#define 	 ID_VARUPDATE	0x5631

#define		 ENTRIES(a)  (sizeof(a)/sizeof((a)[0]))

BEGIN_MESSAGE_MAP(CMathViewerDlg, CDialog)
	//{{AFX_MSG_MAP(CMathViewerDlg)
	ON_WM_SIZE()
	ON_WM_PAINT()
	ON_WM_TIMER()
	ON_WM_SIZING()
	ON_WM_DESTROY()
	ON_WM_HSCROLL()
	ON_WM_CTLCOLOR()
	ON_WM_SYSCOMMAND()
	ON_WM_QUERYDRAGICON()
	ON_EN_CHANGE    (IDC_EDIT1,	 OnChange)
	ON_BN_CLICKED   (IDC_SAVE,   OnSave)
	ON_BN_CLICKED   (IDC_LOAD,   OnLoad)
	ON_BN_CLICKED   (IDC_CHECK3, OnClick)
	ON_BN_CLICKED   (IDC_OPTIONS,OnOptions)
	ON_BN_CLICKED   (IDC_PICTURE,OnPicture)
	ON_CBN_SELCHANGE(IDC_COMBOX, OnChangeComboxX)
	ON_CBN_SELCHANGE(IDC_COMBOY, OnChangeComboxY)
	ON_CBN_SELCHANGE(IDC_COMBOZ, OnChangeComboxZ)
	ON_CBN_SELCHANGE(IDC_COMBO1, OnChangeCombox1)
	ON_CBN_SELCHANGE(IDC_COMBO2, OnChangeCombox2)
	ON_CBN_SELCHANGE(IDC_COMBO3, OnChangeCombox3)
	ON_CBN_SELCHANGE(IDC_COMBO4, OnChangeCombox4)
	ON_CBN_SELCHANGE(IDC_COMBO5, OnChangeCombox5)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_HELP,			 OnHelp)
	ON_COMMAND(ID_REDRAW,		 OnRedraw)
	ON_COMMAND(ID_VARUPDATE,	 OnVarUpdate)
	ON_COMMAND(ID_VALUE_CHG,	 OnValueChanged)
	ON_COMMAND(ID_OPTION_CHG,	 OnOptionChanged)
	ON_NOTIFY(TVN_ITEMSMOVED	,IDC_LIST,OnItemsMoved)
	ON_NOTIFY(TVN_ENDLABELEDIT  ,IDC_LIST,OnListEndEdit)
	ON_NOTIFY(TVN_CBSTATECHANGED,IDC_LIST,OnChangeNotify)
END_MESSAGE_MAP()

#define 	VAL_NAN		(*(double*)"\x00\x00\x00\x00 \x00\x00\xFF\x7F")
#define 	UNIT_MIN	0.000000000001
LPCTSTR	pUnitNames[] =
	{
	"p",
	"n",
	"",
	"m",
	"",
	"k",
	"M",
	"G",
	"T",
	};

LPCTSTR	pScalaNames[] =
	{
	"lin",
	"log",
	"M X",
	"M Y1",
	"M Y2",
	"M Y3",
	};

LPCTSTR	pReservedNames[] =
	{
	"E",
	"PI",
	"ABS",
	"ROUND",
	"FLOOR",
	"SIN",
	"COS",
	"TAN",
	"COT",
	"ASIN",
	"ACOS",
	"ATAN",
	"ACOT",
	"SQRT",
	"*ROOT",
	"LN",
	"LOG",
	"*LOG",
	};

static		char		aAbcBits[32];
#define 	ERR_COLOR	RGB(255,222,222)
CBrush		CMathViewerDlg::m_sErrBrush(ERR_COLOR);


//*****************************************************************************
//*
//*		CDialog
//*
//*****************************************************************************
//  CMathViewerDlg Dialogfeld
CMathViewerDlg::CMathViewerDlg(CWnd *pParent): CDialog(CMathViewerDlg::IDD,pParent)
{
int		iPos;




	//{{AFX_DATA_INIT(CMathViewerDlg)
	m_sFormular		= _T("");
	m_bSel2D		= FALSE;
	//}}AFX_DATA_INIT

	m_sXorDash.CreatePen(PS_DOT,1,RGB(0,0,~247));
	m_hIcon			= AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_bInit			= FALSE;
	m_bIs2D			= FALSE;
	m_bMouseMode	= FALSE;
	m_uError		= 0;
	m_uClickNr		= 0;
	m_uErrorChg		= 0;
	m_uLastUsed		= 0;
	m_uEquCount 	= 0;
	m_uEquErrors	= 0;
	m_uEquUpdate	= 0;
	m_uEquListCnt	= 0;
	m_pEquWnd		= 0;
	m_bLoadOption	= 0;
	m_bDrawRunning	= 0;
	m_bDrawStop		= 0;
	m_bDrawLock		= 0;
	m_bDrawStart	= 0;
	m_bDrawReinit	= 0;
	m_pDrawResults	= 0;
	m_iDrawResCnt	= 0;
	m_uConstEquCnt	= 0;
	m_uPostEquCnt	= 0;
	m_uDrawEquCnt	= 0;
	m_iStoreMode	= 0;
	m_uStoreX		= 1024;
	m_uStoreY		= 768;
	m_iXorMode		= 0;
	m_iXorOn		= 0;
	m_bPanelValid	= 0;
	m_bMouseFlag	= 0;
	m_uVarCount		= 0;
	m_uVarListCnt	= 0;
	m_aEquList[0]	= 0xFF;

	m_uOptions2D    = CDR_DOUBLE;
//	m_uOptions2D   |= CDR_SHADOW;
//	m_uOptions2D   |= CDR_HAS_Y2;
//	m_uOptions2D   |= CDR_3LINES;
//	m_uOptions2D   |= CDR_FILL_1;
//	m_uOptions2D   |= CDR_FILL_2;
//	m_uOptions2D   |= CDR_FILL_3;
	m_uOptions2D   |= CDR_GRID_X;
	m_uOptions2D   |= CDR_GRID_Y;
	m_uOptions2D   |= CDR_SCALA_X;
	m_uOptions2D   |= CDR_SCALA_1;
	m_uOptions2D   |= CDR_SCALA_2;
	m_uOptions2D   |= CDR_SCALA_3;

	m_uOptions3D	= PDR_DOUBLE;
//	m_uOptions3D   |= PDR_QUARD;
	m_uOptions3D   |= PDR_GRID;
	m_uOptions3D   |= PDR_PLANE;
//	m_uOptions3D   |= PDR_SHADOW;
//	m_uOptions3D   |= PDR_COLORFIELD;
	m_uOptions3D   |= PDR_COLORBAR;
	m_uOptions3D   |= PDR_LIGHT;
	m_uOptions3D   |= PDR_TEXT_X;
	m_uOptions3D   |= PDR_TEXT_Y;
	m_uOptions3D   |= PDR_TEXT_Z;
	m_uOptions3D   |= PDR_SCALA_X;
	m_uOptions3D   |= PDR_SCALA_Y;
	m_uOptions3D   |= PDR_SCALA_Z;

	m_sParams3D.dLook			=  0.0;
	m_sParams3D.dZoom			=  0.0;
	m_sParams3D.dRollX			=  0.0;
	m_sParams3D.dRollY			=  0.0;
	m_sParams3D.dRollZ			= 36.0;
	m_sParams3D.dShadow			=  0.0;
	m_sParams3D.iShadowPlane	=  2;

	m_aDrawEquList[0]	= 0xFF;
	m_aPostEquList[0]	= 0xFF;
	m_aConstEquList[0]	= 0xFF;

	memset(m_aVarSet    ,0,sizeof(m_aVarSet    ));
	memset(m_aVarMark   ,0,sizeof(m_aVarMark   ));
	memset(m_aVarColor  ,0,sizeof(m_aVarColor  ));
	memset(m_aOutIndex  ,0,sizeof(m_aOutIndex  ));
	memset(m_aInpIndex  ,0,sizeof(m_aInpIndex  ));
	memset(m_aDrawEquVar,0,sizeof(m_aDrawEquVar));

	m_sVarList .DataLength(sizeof(int));
	m_sVarClick.DataLength(sizeof(int));

	for(iPos=0;iPos<MAX_VAR;iPos++)
		{
		m_aVarMin    [iPos] = 0.0;
		m_aVarMax    [iPos] = 0.0;
		m_aVarValue  [iPos] = 0.0;
		m_aUnitScale [iPos] = 1.0;
		m_aMinMaxErr [iPos] = 0;
		m_aVarError  [iPos] = 0;
		m_aVarMinOk  [iPos] = 0;
		m_aVarMaxOk  [iPos] = 0;
		m_aVarValueOk[iPos] = 0;
		m_aVarScala  [iPos] = 0;
		m_aVarIntern [iPos] = 0;
		m_aVarEqation[iPos] =-1;
		}

	for(iPos=0;iPos<ENTRIES(m_aComboRow);iPos++)
		{
		m_aCombo   [iPos] =  0;
		m_aComboErr[iPos] =  0;
		m_aComboRow[iPos] = -1;
		}

	strtobits(aAbcBits,"0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz_");
}

//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CMathViewerDlg::~CMathViewerDlg()
{
	if(m_pDrawResults)
		{
		delete m_pDrawResults;
		m_pDrawResults=0;
		}
}

//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CMathViewerDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMathViewerDlg)
	DDX_Text (pDX, IDC_EDIT1,  m_sFormular);
	DDX_Check(pDX, IDC_CHECK3, m_bSel2D);
	//}}AFX_DATA_MAP
}

//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
//  CMathViewerDlg Nachrichten-Handler
BOOL CMathViewerDlg::OnInitDialog()
{
CMenu      *pSysMenu;
LPCTSTR		pText;
HTREEITEM	hItem;
CString		sName;
CString		sText;
CRegKeys	sKey;
int			iIni;
int			iPos;
int			iVal;



	iIni	  = 0;
	m_pEquWnd = GetDlgItem(IDC_EDIT1);

	GetClientRect(&m_cRect);

	m_iMinX   = m_cRect.Width();
	m_iMinY   = m_cRect.Height();

	GetWindowRect(&m_cRect);

	m_iStartX = m_cRect.Width();
	m_iStartY = m_cRect.Height();

	m_cBitmapWnd.CreateEx(WS_EX_STATICEDGE,IDC_FRAME,this,IDC_PAINT);
	m_cListWnd	.CreateEx(WS_EX_STATICEDGE,TVS_AUTODRAGMOVE|TVS_EDITLABELS|TVS_FULLROWSELECT|WS_TABSTOP|TVS_CHECKBOXES,IDC_LISTPOS,this,IDC_LIST);
	m_cListWnd  .SetExtendedStyle(TVS_EX_ALTERNATECOLOR|TVS_EX_FULLROWMARK|TVS_EX_SUBSELECT|TVS_EX_ITEMLINES|TVS_EX_BITCHECKBOX);
	m_cListWnd  .InsertColumn(0,"Variable",TVCFMT_LEFT ,-25);
	m_cListWnd  .InsertColumn(1,"Wert"    ,TVCFMT_RIGHT,-25);
	m_cListWnd  .InsertColumn(2,"Min"     ,TVCFMT_RIGHT,-25);
	m_cListWnd  .InsertColumn(3,"Max"     ,TVCFMT_RIGHT,-25);
	m_cListWnd  .InsertColumn(4,"Einheit" ,TVCFMT_LEFT ,-16);
	m_cListWnd  .InsertColumn(5,"Skala"   ,TVCFMT_LEFT ,-14);

	m_cListWnd  .SetColumnAutoEdit(0,TVAE_DBLCLICK|TVAE_FULLWIDTH|TVAE_EDIT);
	m_cListWnd  .SetColumnAutoEdit(1,TVAE_DBLCLICK|TVAE_FULLWIDTH|TVAE_EDIT);
	m_cListWnd  .SetColumnAutoEdit(2,TVAE_DBLCLICK|TVAE_FULLWIDTH|TVAE_EDIT);
	m_cListWnd  .SetColumnAutoEdit(3,TVAE_DBLCLICK|TVAE_FULLWIDTH|TVAE_EDIT);
	m_cListWnd  .SetColumnAutoEdit(4,TVAE_DBLCLICK|TVAE_FULLWIDTH|TVAE_CBLIST|TVAE_DROPDOWN,pUnitNames ,ENTRIES(pUnitNames ));
	m_cListWnd  .SetColumnAutoEdit(5,TVAE_DBLCLICK|TVAE_FULLWIDTH|TVAE_CBLIST|TVAE_DROPDOWN,pScalaNames,ENTRIES(pScalaNames));


	m_aCombo   [0] = GetDlgComboBox(IDC_COMBOX);
	m_aCombo   [1] = GetDlgComboBox(IDC_COMBOY);
	m_aCombo   [2] = GetDlgComboBox(IDC_COMBOZ);
	m_aCombo   [3] = GetDlgComboBox(IDC_COMBO1);
	m_aCombo   [4] = GetDlgComboBox(IDC_COMBO2);
	m_aCombo   [5] = GetDlgComboBox(IDC_COMBO3);
	m_aCombo   [6] = GetDlgComboBox(IDC_COMBO4);
	m_aCombo   [7] = GetDlgComboBox(IDC_COMBO5);

	m_aSlider  [0] = GetDlgSliderCtrl(IDC_SLIDERX);
	m_aSlider  [1] = GetDlgSliderCtrl(IDC_SLIDERY);
	m_aSlider  [2] = GetDlgSliderCtrl(IDC_SLIDERZ);
	m_aSlider  [3] = GetDlgSliderCtrl(IDC_SLIDER1);
	m_aSlider  [4] = GetDlgSliderCtrl(IDC_SLIDER2);
	m_aSlider  [5] = GetDlgSliderCtrl(IDC_SLIDER3);
	m_aSlider  [6] = GetDlgSliderCtrl(IDC_SLIDER4);
	m_aSlider  [7] = GetDlgSliderCtrl(IDC_SLIDER5);

	m_aSizeWnd [0] = GetDlgItem(IDC_EDIT1);
	m_aSizeWnd [1] = GetDlgItem(IDC_LIST);
	m_aSizeWnd [2] = GetDlgItem(IDC_PAINT);
	m_aSizeWnd [3] = GetDlgItem(IDC_SLIDER1);
	m_aSizeWnd [4] = GetDlgItem(IDC_SLIDER2);
	m_aSizeWnd [5] = GetDlgItem(IDC_SLIDER3);
	m_aSizeWnd [6] = GetDlgItem(IDC_SLIDER4);
	m_aSizeWnd [7] = GetDlgItem(IDC_SLIDER5);

	m_aSizeType[0] = 0x01;
	m_aSizeType[1] = 0x02;
	m_aSizeType[2] = 0x03;
	m_aSizeType[3] = 0x01;
	m_aSizeType[4] = 0x01;
	m_aSizeType[5] = 0x01;
	m_aSizeType[6] = 0x01;
	m_aSizeType[7] = 0x01;

	for(iPos=0;iPos<ENTRIES(m_aSizeWnd);iPos++)
		{
		m_aSizeWnd[iPos]->GetWindowRect(m_aSizeRect+iPos);
		}

	for(iPos=0;iPos<ENTRIES(m_aSlider);iPos++)
		{
		m_aSlider[iPos]->SetTicFreq(5);
		m_aSlider[iPos]->SetLineSize(2);
		m_aSlider[iPos]->SetPageSize(10);
		m_aSlider[iPos]->SetScrollRange(0,100,0);
		}



	sKey.Open(HKEY_CURRENT_USER,"Software\\AZ\\MathViewer");
	sKey.Get (m_sFormular				,"Formular"	    );
	sKey.Get (m_bSel2D					,"Select2D"     );
	sKey.Get (m_bLoadOption				,"LoadOption"   );
	sKey.Get (m_uOptions2D				,"Option2D"     );
	sKey.Get (m_uOptions3D				,"Option3D"     );
	sKey.Get (m_sTempTextX				,"TempTextX"	);
	sKey.Get (m_sTempTextY3				,"TempTextY3"	);
	sKey.Get (m_sParams3D.dLook			,"Look3D"	    );
	sKey.Get (m_sParams3D.dZoom			,"Zoom3D"	    );
	sKey.Get (m_sParams3D.dRollX		,"RoolX3D"	    );
	sKey.Get (m_sParams3D.dRollY		,"RoolY3D"	    );
	sKey.Get (m_sParams3D.dRollZ		,"RoolZD"	    );
	sKey.Get (m_sParams3D.dShadow		,"ShadowPos3D"  );
	sKey.Get (m_sParams3D.iShadowPlane	,"ShadowPlane3D");
	sKey.Get (iIni						,"DemoShown"    );



	for(iPos=0;iPos<ENTRIES(m_aComboTxt);iPos++)
		{
		sText.Format("Select%i",iPos);
		sKey.Get(m_aComboTxt[iPos],sText);
		}

	for(iPos=0;iPos<MAX_VAR;iPos++)
		{
		sName = _T("");
		sText.Format(_T("Var%03iName"),iPos);
		sKey.Get(sName,sText);
		if(sName==_T(""))continue;

		hItem = m_cListWnd.InsertItem(sName);

		sName = _T("");
		sText.Format(_T("Var%03iValue"),iPos);
		sKey.Get(sName,sText);
		if(sName.IsEmpty())sName=_T("0");
		m_cListWnd.SetItemText(hItem,sName,1);

		sName = _T("");
		sText.Format(_T("Var%03iMin"),iPos);
		sKey.Get(sName,sText);
		if(sName.IsEmpty())sName=_T("0");
		m_cListWnd.SetItemText(hItem,sName,2);

		sName = _T("");
		sText.Format(_T("Var%03iMax"),iPos);
		sKey.Get(sName,sText);
		if(sName.IsEmpty())sName=_T("0");
		m_cListWnd.SetItemText(hItem,sName,3);

		sName = _T("");
		sText.Format(_T("Var%03iUnit"),iPos);
		sKey.Get(sName,sText);
		m_cListWnd.SetItemText(hItem,sName,4);

		sName = _T("");
		sText.Format(_T("Var%03iScala"),iPos);
		sKey.Get(sName,sText);
		if(sName.IsEmpty())sName=pScalaNames[0];
		m_cListWnd.SetItemText(hItem,sName,5);

		sName = _T("");
		sText.Format(_T("Var%03iConst"),iPos);
		sKey.Get(iVal,sText);
		iVal  = m_cListWnd.SetItemCheckBox(hItem,iVal&1);

		UpdateUnit(iPos);
		GetValue(iPos,1);
		GetValue(iPos,2);
		GetValue(iPos,3);
		GetValue(iPos,5);
		}


	for(iPos=0;iPos<(int)m_uVarListCnt;iPos++)					// Marker und Skalierung auswerten
		{
			pText = m_cListWnd.ListGetItemText(iPos,5);
		if(!pText)break;

		for(iVal=ENTRIES(pScalaNames)-1;iVal>0;iVal--)
			{
			if(!_tcsicmp(pText,pScalaNames[iVal]))break;
			}

		if(iVal<2)
			{
			m_aVarScala[iPos] = iVal;
			}
		else{
			m_aVarScala[iPos] = 0;
			}
		}


	hItem = m_cListWnd.InsertItem(_T(""));
	m_pEquWnd->SetWindowText(m_sFormular);

	UpdateList();
	UpdateSliders();
	UpdateEquations();
	UpdateErros();
	UpdateCalculator();
	UpdateValues();

	CDialog::OnInitDialog();

	OnClick();

	m_bInit = TRUE;

	ASSERT((ID_DEMO2D   &0xFFF0)==ID_DEMO2D);
	ASSERT((ID_DEMO2D   <0xF000));
	ASSERT((ID_DEMO3D   &0xFFF0)==ID_DEMO3D);
	ASSERT((ID_DEMO3D   <0xF000));
	ASSERT((ID_SHOWEQU  &0xFFF0)==ID_SHOWEQU);
	ASSERT((ID_SHOWEQU  <0xF000));
	ASSERT((ID_SHOWHLP  &0xFFF0)==ID_SHOWHLP);
	ASSERT((ID_SHOWHLP  <0xF000));
	ASSERT((IDM_ABOUTBOX&0xFFF0)==IDM_ABOUTBOX);
	ASSERT((IDM_ABOUTBOX<0xF000));

	   pSysMenu = GetSystemMenu(FALSE);
	if(pSysMenu!=NULL)
		{
		CString		sAboutMenu;

		sAboutMenu.LoadString(IDS_ABOUTBOX);

		if(!sAboutMenu.IsEmpty())
			{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING,IDM_ABOUTBOX,sAboutMenu);
			}

		pSysMenu->AppendMenu(MF_STRING,ID_SHOWEQU,_T("Rechenweg anzeigen"));
		pSysMenu->AppendMenu(MF_STRING,ID_SHOWHLP,_T("Hilfe anzeigen"));
		pSysMenu->AppendMenu(MF_STRING,ID_DEMO2D ,_T("2D Demo"));
		pSysMenu->AppendMenu(MF_STRING,ID_DEMO3D ,_T("3D Demo"));
		}

	SetIcon(m_hIcon,TRUE ); 									// Groes Symbol verwenden
	SetIcon(m_hIcon,FALSE);										// Kleines Symbol verwenden


	if(m_iStoreMode)											// ber Kommandozeile laden
		{
		Load(m_sStoreLoad,FALSE);

		if(m_iStoreMode>=2)										// Nur ein Bild speichern
			{
			EndDialog(DoStore());
			return FALSE;
			}
		}

	for(iPos=0;iPos<(int)m_uVarListCnt;iPos++)					// Marker und Skalierung auswerten
		{
			pText = m_cListWnd.ListGetItemText(iPos,5);
		if(!pText)break;

		for(iVal=ENTRIES(pScalaNames)-1;iVal>0;iVal--)
			{
			if(!_tcsicmp(pText,pScalaNames[iVal]))break;
			}

		if(iVal<2)
			{
			m_aVarScala[iPos] = iVal;
			m_aVarMark [iPos] = 0;
			}
		else{
			m_aVarScala[iPos] = 0;
			m_aVarMark [iPos] = iVal-1;
			}
		}


	SetTimer(ID_EQUTICK,400,NULL);
	AfxBeginThread(DrawProc,this);


	if(!iIni)													// Demo beim erstenmal anzeigen
		{
		GetExeName(sText);
		ConfigFileIcon   ("MVI",sText,0,"Mathematische Formel");
		ConfigFileCommand("MVI",sText);

		sKey.Set(1,"DemoShown");
		Load("res://Demo3D",TRUE);
		}

	m_cBitmapWnd.SetDrawCallback (DrawCallback ,this);
	m_cBitmapWnd.SetMouseCallback(MouseCallback,this);


return TRUE;
}

//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CMathViewerDlg::OnDestroy()
{

	ShowWindow(SW_HIDE);

	while(m_bDrawRunning)
		{
		m_bDrawStop = 1;
		m_sDrawTicker.Unlock();
		}

	CDialog::OnDestroy();

}

//*****************************************************************************
//*
//*		OnSysCommand
//*
//*****************************************************************************
void CMathViewerDlg::OnSysCommand(UINT nID,LPARAM lParam)
{
	if((nID&0xFFF0)==IDM_ABOUTBOX)
		{
		CDialog	sDlg(IDD_ABOUTBOX);

		sDlg.DoModal();
		}
	else if((nID&0xFFF0)==ID_DEMO2D)
		{
		Load("res://Demo2D",TRUE);
		}
	else if((nID&0xFFF0)==ID_DEMO3D)
		{
		Load("res://Demo3D",TRUE);
		}
	else if((nID&0xFFF0)==ID_SHOWHLP)
		{
		OnHelp();
		}
	else if((nID&0xFFF0)==ID_SHOWEQU)
		{
		CInfoDlg		sDlg;
		TCHAR			cText[0x10000];
		char			cColor[sizeof(cText)];
		UINT			uPos;
		UINT			uLen;
		UINT			uNum;
		UINT			uEqu;
		UINT			uOff;


		uLen = 0;

		if(m_aEquConst[0]!=0xFF)
			{
			uNum  = xsnprintf(cText+uLen,ENTRIES(cText)-uLen,_T("Konstanten:\n\n"));
			memset(cColor+uLen,0x00,uNum);
			uLen += uNum;

			for(uOff=0;;uOff++)
				{
				   uEqu = m_aEquConst[uOff];
				if(uEqu==0xFF)break;

				uNum  = xsnprintf(cText+uLen,ENTRIES(cText)-uLen,_T("  %-8s = "),m_aEquResult[uEqu]);
				memset(cColor+uLen,0x04,uNum-2);
				uLen += uNum;
				memset(cColor+uLen-2,0x00,2);

				uNum  = xsnprintf(cText+uLen,ENTRIES(cText)-uLen,_T("%s\n"),m_aEquations[uEqu]);
				memset(cColor+uLen,0x02,uNum);
				uLen += uNum;
				}

			uNum  = xsnprintf(cText+uLen,ENTRIES(cText)-uLen,_T("\n"));
			memset(cColor+uLen,0x00,uNum);
			uLen += uNum;
			}


		if(m_aEquPost[0]!=0xFF)
			{
			uNum  = xsnprintf(cText+uLen,ENTRIES(cText)-uLen,_T("Nachberechnung:\n\n"));
			memset(cColor+uLen,0x00,uNum);
			uLen += uNum;

			for(uOff=0;;uOff++)
				{
				   uEqu = m_aEquPost[uOff];
				if(uEqu==0xFF)break;

				uNum  = xsnprintf(cText+uLen,ENTRIES(cText)-uLen,_T("  %-8s = "),m_aEquResult[uEqu]);
				memset(cColor+uLen,0x04,uNum-2);
				uLen += uNum;
				memset(cColor+uLen-2,0x00,2);

				uNum  = xsnprintf(cText+uLen,ENTRIES(cText)-uLen,_T("%s\n"),m_aEquations[uEqu]);
				memset(cColor+uLen,0x02,uNum);
				uLen += uNum;
				}

			uNum  = xsnprintf(cText+uLen,ENTRIES(cText)-uLen,_T("\n"));
			memset(cColor+uLen,0x00,uNum);
			uLen += uNum;
			}


		for(uPos=0;uPos<m_uEquListCnt;uPos++)
			{
			uNum  = xsnprintf(cText+uLen,ENTRIES(cText)-uLen,_T("Formel%i:\n\n"),uPos+1);
			memset(cColor+uLen,0x00,uNum);
			uLen += uNum;

			for(uOff=0;;uOff++)
				{
				   uEqu = m_aEquList[MAX_EQU*uPos+uOff];
				if(uEqu==0xFF)break;

				uNum  = xsnprintf(cText+uLen,ENTRIES(cText)-uLen,_T("  %-8s = "),m_aEquResult[uEqu]);
				memset(cColor+uLen,0x04,uNum-2);
				uLen += uNum;
				memset(cColor+uLen-2,0x00,2);

				uNum  = xsnprintf(cText+uLen,ENTRIES(cText)-uLen,_T("%s\n"),m_aEquations[uEqu]);
				memset(cColor+uLen,0x02,uNum);
				uLen += uNum;
				}

			uNum  = xsnprintf(cText+uLen,ENTRIES(cText)-uLen,_T("\n"));
			memset(cColor+uLen,0x00,uNum);
			uLen += uNum;
			}


		sDlg.SetText(cText,cColor);

		sDlg.DoModal();
		}
	else{
		CDialog::OnSysCommand(nID, lParam);
		}

}

//*****************************************************************************
//*
//*		OnCtlColor
//*
//*****************************************************************************
HBRUSH CMathViewerDlg::OnCtlColor(CDC *pDC,CWnd *pWnd,UINT nCtlColor)
{
int		iPos;


	for(iPos=0;iPos<3;iPos++)
		{
		if(m_aComboErr[iPos]==0)continue;
		if(m_aCombo   [iPos]==0)continue;
		if(m_aCombo   [iPos]->m_hWnd!=pWnd->m_hWnd)continue;

		pDC->SetBkColor(ERR_COLOR);

		return m_sErrBrush;
		}

	if(m_pEquWnd && m_pEquWnd->m_hWnd==pWnd->m_hWnd && m_uEquErrors)
		{
		pDC->SetBkColor(ERR_COLOR);
		return m_sErrBrush;
		}


return CDialog::OnCtlColor(pDC,pWnd,nCtlColor);
}

//*****************************************************************************
//*
//*		OnPaint
//*
//*****************************************************************************
//  Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie
// 	den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das
// 	Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.
void CMathViewerDlg::OnPaint()
{
int		iIconX;
int		iIconY;
int		x,y;

	if(IsIconic())
		{
		CPaintDC dc(this);										// Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		iIconX = GetSystemMetrics(SM_CXICON);					// Symbol in Client-Rechteck zentrieren
		iIconY = GetSystemMetrics(SM_CYICON);

		CRect sRect;

		GetClientRect(&sRect);
		x = (sRect.Width () - iIconX + 1) / 2;
		y = (sRect.Height() - iIconY + 1) / 2;

		dc.DrawIcon(x,y,m_hIcon);								// Symbol zeichnen
		}
	else{
		CDialog::OnPaint();
		}
}

//*****************************************************************************
//*
//*		OnQueryDragIcon
//*
//*****************************************************************************
HCURSOR CMathViewerDlg::OnQueryDragIcon()
{

return (HCURSOR) m_hIcon;
}

//*****************************************************************************
//*
//*		OnSizing
//*
//*****************************************************************************
void CMathViewerDlg::OnSizing( UINT nSide, LPRECT pRect )
{


	if(pRect->right-pRect->left<m_iStartX)
		{
		if(nSide==WMSZ_BOTTOMLEFT ||
		   nSide==WMSZ_TOPLEFT 	  ||
		   nSide==WMSZ_LEFT)
			{
			pRect->left = pRect->right-m_iStartX;
			}
		else{
			pRect->right = pRect->left+m_iStartX;
			}
		}

	if(pRect->bottom-pRect->top<m_iStartY)
		{
		if(nSide==WMSZ_TOPRIGHT ||
		   nSide==WMSZ_TOPLEFT  ||
		   nSide==WMSZ_TOP)
			{
			pRect->top = pRect->bottom-m_iStartY;
			}
		else{
			pRect->bottom = pRect->top+m_iStartY;
			}
		}

}

//*****************************************************************************
//*
//*		OnSize
//*
//*****************************************************************************
void CMathViewerDlg::OnSize(UINT nType,int iSizeX,int iSizeY)
{
int		iPixelX;
int		iPixelY;
int		iPos;


	m_bPanelValid = 0;
	m_iSizeX = iSizeX;
	m_iSizeY = iSizeY;

	CDialog::OnSize(nType,iSizeX,iSizeY);

	if(!m_bInit)return;


	for(iPos=0;iPos<ENTRIES(m_aSizeRect);iPos++)
		{
		iPixelX = m_aSizeRect[iPos].Width ();
		iPixelY = m_aSizeRect[iPos].Height();

		if(m_aSizeType[iPos]&0x01)iPixelX+=iSizeX-m_iMinX;
		if(m_aSizeType[iPos]&0x02)iPixelY+=iSizeY-m_iMinY;

		m_aSizeWnd[iPos]->SetWindowPos(NULL,0,0,iPixelX,iPixelY,SWP_NOMOVE|SWP_NOOWNERZORDER);
		m_bDrawReinit = TRUE;
		}

}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void CMathViewerDlg::OnCancel()
{
	SaveRegistry();
	CDialog::OnCancel();
}

//*****************************************************************************
//*
//*		GetValue
//*
//*****************************************************************************
//	Holt einen Wert aus einem Feld.
//	uRow		: Reihe des Feldes
//	uCol		: Spalte (1=Wert 2=Min 3=Max)
//	iScale		: Die Skalierung umrechen
//	Ergibt den Wert.
double CMathViewerDlg::GetValue(UINT uRow,UINT uCol,int iScale)
{
LPCTSTR		pText;
double		dVal;
double		dMul;
int			iLen;



		pText = m_cListWnd.ListGetItemText(uRow,uCol);
	if(!pText)return 0.0;

	if(m_uVarListCnt<uRow && *pText)
		{
		m_uVarListCnt = uRow+1;
		}

	if(uCol==5)
		{
		if(!_tcsicmp(pText,pScalaNames[1]))
				dVal=1;
		else	dVal=0;
		}
	else{
		pText += strwlen(pText, 0xE0);
		dVal   = strtof (pText,&iLen,0x07);
		pText += iLen;
		pText += strwlen(pText, 0xE0);
		}


	if(uRow<MAX_VAR)											// Daten aktualisieren
		{
		if(iScale)
			{
			dMul  = 1.0;
			dVal *= m_aUnitScale[uRow];
			}
		else{
			dMul  = m_aUnitScale[uRow];
			}

		if(uCol==1){m_aVarValue[uRow]=dVal*dMul;m_aVarValueOk[uRow]=iLen;}
		if(uCol==2){m_aVarMin  [uRow]=dVal*dMul;m_aVarMinOk  [uRow]=iLen;}
		if(uCol==3){m_aVarMax  [uRow]=dVal*dMul;m_aVarMaxOk  [uRow]=iLen;}
		if(uCol==5){m_aVarScala[uRow]=(UINT)dVal;}
		}


return dVal;
}

//*****************************************************************************
//*
//*		SetValue
//*
//*****************************************************************************
//	Speichert einen Wert aus einem Feld.
//	uRow		: Reihe des Feldes
//	uCol		: Spalte (1=Wert 2=Min 3=Max)
//	iScale		: Die Skalierung umrechen (2=auch Schrifttyp setzen)
void CMathViewerDlg::SetValue(double dValue,UINT uRow,UINT uCol,int iScale)
{
TCHAR		cText[64];
LPCTSTR		pText;
UINT		uMode;



	if(uCol==5)
		{
		if(dValue!=0.0)
			{
			m_cListWnd.ListSetItemText(uRow,pScalaNames[1],uCol);
			m_aVarScala[uRow] = 1;
			}
		else{
			m_cListWnd.ListSetItemText(uRow,pScalaNames[0],uCol);
			m_aVarScala[uRow] = 0;
			}

		return;
		}

	if((iScale&1) && uRow<MAX_VAR)
		{
		dValue /= m_aUnitScale[uRow];
		}

	xsnprintf(cText,64,"%7g",dValue);
	strcut(cText);

	pText = m_cListWnd.ListGetItemText(uRow,uCol);

	if(pText && _tcscmp(cText,pText))
		{
		m_cListWnd.ListSetItemText(uRow,cText,uCol);
		}

	if(iScale&2)										// Schrifttyp setzen
		{
		if(iScale&4)
			{
			uMode = TVIS_BOLD;
			}
		else{
			uMode = 0;

			if(uRow<MAX_VAR && m_aVarType[uRow]>=TYPE_EQUCONST && !m_aVarSet[uRow])
				{
				uMode |= TVIS_UNDERLINE;
				}
			}

		m_cListWnd.ListSetItemState(uRow,uCol,uMode,TVIS_BOLD|TVIS_UNDERLINE);
		}

	if(uRow<MAX_VAR)
		{
		if(uCol==1)m_aVarValue[uRow]=dValue*m_aUnitScale[uRow];
		if(uCol==2)m_aVarMin  [uRow]=dValue*m_aUnitScale[uRow];
		if(uCol==3)m_aVarMax  [uRow]=dValue*m_aUnitScale[uRow];
		}


}

//*****************************************************************************
//*
//*		SaveRegistry
//*
//*****************************************************************************
void CMathViewerDlg::SaveRegistry()
{
LPCTSTR		pName;
LPCTSTR		pText;
CString		sText;
CRegKeys	sKey;
int			iPos;
int			iVal;


	UpdateData();



	sKey.Open(HKEY_CURRENT_USER,"Software\\AZ\\MathViewer");
	sKey.Set (m_sFormular				,"Formular"	    );
	sKey.Set (m_bSel2D					,"Select2D"     );
	sKey.Set (m_bLoadOption				,"LoadOption"   );
	sKey.Set (m_uOptions2D				,"Option2D"     );
	sKey.Set (m_uOptions3D				,"Option3D"     );
	sKey.Set (m_sTempTextX				,"TempTextX"	);
	sKey.Set (m_sTempTextY3				,"TempTextY3"	);
	sKey.Set (m_sParams3D.dLook			,"Look3D"	    );
	sKey.Set (m_sParams3D.dZoom			,"Zoom3D"	    );
	sKey.Set (m_sParams3D.dRollX		,"RoolX3D"	    );
	sKey.Set (m_sParams3D.dRollY		,"RoolY3D"	    );
	sKey.Set (m_sParams3D.dRollZ		,"RoolZD"	    );
	sKey.Set (m_sParams3D.dShadow		,"ShadowPos3D"  );
	sKey.Set (m_sParams3D.iShadowPlane	,"ShadowPlane3D");

	for(iPos=0;iPos<ENTRIES(m_aComboTxt);iPos++)
		{
		sText.Format("Select%i",iPos);
		sKey.Set(m_aComboTxt[iPos],sText);
		}

	for(iPos=0;iPos<MAX_VAR;iPos++)
		{
		sText.Format(_T("Var%03iName"),iPos);
		pName = m_cListWnd.ListGetItemText(iPos,0);
		if(!pName || !*pName)break;
		sKey.Set(pName,sText);

		sText.Format(_T("Var%03iValue"),iPos);
		pName = m_cListWnd.ListGetItemText(iPos,1);
		sKey.Set(pName,sText);

		sText.Format(_T("Var%03iMin"),iPos);
		pName = m_cListWnd.ListGetItemText(iPos,2);
		sKey.Set(pName,sText);

		sText.Format(_T("Var%03iMax"),iPos);
		pName = m_cListWnd.ListGetItemText(iPos,3);
		sKey.Set(pName,sText);

		sText.Format(_T("Var%03iUnit"),iPos);
		pName = m_cListWnd.ListGetItemText(iPos,4);
		sKey.Set(pName,sText);

		sText.Format(_T("Var%03iScala"),iPos);
		pName = m_cListWnd.ListGetItemText(iPos,5);
		sKey.Set(pName,sText);

		sText.Format(_T("Var%03iConst"),iPos);
		iVal  = m_cListWnd.ListGetItemCheckBox(iPos);
		sKey.Set(iVal,sText);
		}

	for(;iPos<MAX_VAR;iPos++)
		{
		sText.Format(_T("Var%03iName"),iPos);
		sKey.Del(sText);

		sText.Format(_T("Var%03iValue"),iPos);
		sKey.Del(sText);

		sText.Format(_T("Var%03iMin"),iPos);
		sKey.Del(sText);

		sText.Format(_T("Var%03iMax"),iPos);
		sKey.Del(sText);

		sText.Format(_T("Var%03iUnit"),iPos);
		sKey.Del(sText);

		sText.Format(_T("Var%03iScala"),iPos);
		sKey.Del(sText);

		sText.Format(_T("Var%03iConst"),iPos);
		sKey.Del(sText);
		}

	for(iPos=0;iPos<(int)m_uVarListCnt;iPos++)					// Marker und Skalierung auswerten
		{
			pText = m_cListWnd.ListGetItemText(iPos,5);
		if(!pText)break;

		for(iVal=ENTRIES(pScalaNames)-1;iVal>0;iVal--)
			{
			if(!_tcsicmp(pText,pScalaNames[iVal]))break;
			}

		if(iVal<2)
			{
			m_aVarScala[iPos] = iVal;
			m_aVarMark [iPos] = 0;
			}
		else{
			m_aVarScala[iPos] = 0;
			m_aVarMark [iPos] = iVal-1;
			}
		}


}

//*****************************************************************************
//*
//*		OnChangeCombox?
//*
//*****************************************************************************
void CMathViewerDlg::OnChangeComboxX(){OnChangeCombox(0);}
void CMathViewerDlg::OnChangeComboxY(){OnChangeCombox(1);}
void CMathViewerDlg::OnChangeComboxZ(){OnChangeCombox(2);}
void CMathViewerDlg::OnChangeCombox1(){OnChangeCombox(3);}
void CMathViewerDlg::OnChangeCombox2(){OnChangeCombox(4);}
void CMathViewerDlg::OnChangeCombox3(){OnChangeCombox(5);}
void CMathViewerDlg::OnChangeCombox4(){OnChangeCombox(6);}
void CMathViewerDlg::OnChangeCombox5(){OnChangeCombox(7);}
void CMathViewerDlg::OnChangeCombox(int iSlider)
{
int		iSel;


	UpdateData();

	iSel = m_aCombo[iSlider]->GetCurSel();
	if(iSel<0)iSel=0;
	m_aCombo[iSlider]->GetLBText(iSel,m_aComboTxt[iSlider]);

	UpdateSliders(iSlider);

	if(iSlider<3)
		{
		UpdateEquations();
		}


	UpdateErros();

	if(iSlider<3)
		{
		UpdateCalculator();
		UpdateValues();
		}

}

//*****************************************************************************
//*
//*		OnVarUpdate
//*
//*****************************************************************************
void CMathViewerDlg::OnVarUpdate()
{

	UpdateValues();

}

//*****************************************************************************
//*
//*		OnItemsMoved
//*
//*****************************************************************************
void CMathViewerDlg::OnItemsMoved(NMHDR *pNmHdr,LRESULT *pResult)
{

	m_uEquUpdate = 3;

}

//*****************************************************************************
//*
//*		OnListEndEdit
//*
//*****************************************************************************
void CMathViewerDlg::OnListEndEdit(NMHDR *pNmHdr,LRESULT *pResult)
{
NMTVDISPINFO   *pItem = (NMTVDISPINFO*)pNmHdr;
double			dScale;
double			dValue;
LPCTSTR			pName;
LPCTSTR			pText;
LPCTSTR			pScal;
CString			sText;
HTREEITEM		hItem;
HTREEITEM		hNext;
int				iChg;
int				iPos;
int				iSub;
int				iRow;
int				iNum;
int				iLen;
int				iVal;


	if(!(pItem->item.mask&TVIF_TEXTCHANGED))			// Hat sich der Text verndert
		{
		*pResult = 1;
		return;
		}
														// Wurde ein Text bergeben
	if(pItem->item.pszText==0 || !(pItem->item.mask&TVIF_TEXT))
		{
		*pResult = 1;
		return;
		}

	hItem	= pItem->item.hItem;
	pText	= pItem->item.pszText;
	iSub	= pItem->item.cChildren;
	iRow	= m_cListWnd.GetRowOfItem(hItem);
	iChg	= 0;


	if(pText[0]==0 && pItem->item.cChildren==0)			// Eintrag lschen
		{
			hNext=m_cListWnd.GetNextItem(hItem);
		if(!hNext)
			{
			m_cListWnd.SetItemBkColor(hItem,0,TV_NOCOLOR);
			m_cListWnd.SetItemBkColor(hItem,0,TV_NOCOLOR);
			m_cListWnd.SetItemBkColor(hItem,0,TV_NOCOLOR);
			m_cListWnd.SetItemBkColor(hItem,0,TV_NOCOLOR);
			return;
			}

		m_cListWnd.DeleteItem(hItem);
		m_cListWnd.SelectItem(hNext);
		if(m_uVarListCnt>0)m_uVarListCnt--;

		for(iRow;iRow<MAX_VAR;iRow++)
			{
			UpdateUnit(iRow);
			GetValue(iRow,1);
			GetValue(iRow,2);
			GetValue(iRow,3);
			}

		UpdateList();									// Neue Variabel Liste
		UpdateSliders();
		UpdateEquations();
		UpdateErros();
		UpdateCalculator();
		UpdateValues();

		return;
		}


	 if(iRow<0 || iRow>=MAX_VAR)return;

														// Leereintrag anhngen
	if(!m_cListWnd.GetNextItem(hItem) && m_cListWnd.GetCount()<MAX_VAR)
		{
		m_uVarListCnt = m_cListWnd.GetRowCount();
		m_cListWnd.InsertItem(_T(""));
		}

	if(pItem->item.cChildren==4)						// Einheit anhngen
		{
		dScale = m_aUnitScale[iRow];

		for(iNum=0;iNum<ENTRIES(pUnitNames);iNum++)
			{
			if(pText[0]==*pUnitNames[iNum])
				{
				pName = pUnitNames[iNum];
				break;
				}
			}

		if(iNum>=ENTRIES(pUnitNames))
			{
			pName = _T("");
			m_aUnitScale[iRow] = 1.0;
			}
		else{
			m_aUnitScale[iRow] = UNIT_MIN*pow(10.0,iNum*3);
			}

		xsnprintf((TCHAR*)pText,pItem->item.cchTextMax,_T("%s%s"),pName,m_aUnitName[iRow]);

		dScale /= m_aUnitScale[iRow];

		if(dScale>1.001 || dScale<0.999)				// Werte umrechen
			{
			for(iNum=1;iNum<=3;iNum++)
				{
				dValue = GetValue(     iRow,iNum,0);
				SetValue(dValue*dScale,iRow,iNum,0);
				}
			}
		}

	if(pItem->item.cChildren==0)						// Einheit finden
		{
			pScal = m_cListWnd.GetItemText(hItem,5);
		if(!pScal || !*pScal)
			{
			m_cListWnd.SetItemText(hItem,pScalaNames[0],5);
			}

		UpdateUnit(iRow,pText);
		UpdateList();
		UpdateSliders();
		UpdateEquations();
		UpdateErros();
		UpdateCalculator();
		UpdateValues();
		iChg |=2;
		}

	if(pItem->item.cChildren==5)						// Einheit finden
		{
		iVal = 0;

		for(iPos=ENTRIES(pScalaNames)-1;iPos>0;iPos--)
			{
			if(!_tcsicmp(pText,pScalaNames[iPos]))break;
			}

		if(!m_bIs2D)
			{
			if(iPos>1)
				{
				_tcscpy((LPTSTR)pText,pScalaNames[0]);
				iPos = 0;
				}
			}
		else{
			if(iPos>1)
				{
				if(iRow==0 && (m_uOptions2D&CDR_3LINES))
					{
					iNum = 0;
					}
				else for(iNum=0;iNum<3;iNum++)
					{
					if(m_aComboRow[iNum]==iRow)break;
					}

				if(iNum<3)								// Marke nicht erlaubt
					{
					_tcscpy((LPTSTR)pText,pScalaNames[0]);
					iPos = m_aVarScala[iRow];
					iVal = 0;
					}
				else{									// Marke erlaubt
					iVal = iPos-1;
					iPos = m_aVarScala[iRow];
					}
				}
			}


		if(m_aVarMark[iRow]!=iVal)
			{
			m_aVarMark[iRow] = iVal;
			iChg |= 2;
			}

		if(m_aVarScala[iRow]!=iPos)
			{
			m_aVarScala[iRow] = iPos;
			iChg |= 2;
			}

		if(iChg&2)
			{
			UpdateUnit(iRow);
			UpdateList();
			UpdateSliders();
			UpdateEquations();
			UpdateValues();
			UpdateErros();
			}
		}
														// Werteingabe finden
	if(pItem->item.cChildren>=1 && pItem->item.cChildren<=3)
		{
		if(pItem->item.cChildren==1)					// Welcher Slider wurde zuletzt benutzt
			{
			if(iRow==m_aComboRow[0])m_uLastUsed=0;
			if(iRow==m_aComboRow[1])m_uLastUsed=1;
			if(iRow==m_aComboRow[2])m_uLastUsed=2;
			}

		pText += strwlen(pText,0xE0);
		dValue = strtof (pText,&iLen,0x07)*m_aUnitScale[iRow];
		iLen  += strwlen(pText +iLen,0xE0);


		if(pItem->item.cChildren==1){m_aVarValueOk[iRow]=iLen;m_aVarValue[iRow]=dValue;}
		if(pItem->item.cChildren==2){m_aVarMinOk  [iRow]=iLen;m_aVarMin  [iRow]=dValue;}
		if(pItem->item.cChildren==3){m_aVarMaxOk  [iRow]=iLen;m_aVarMax  [iRow]=dValue;}


		if(pText[iLen])									// Gibt es Einheiten am Textende
			{
			if(!_tcscmp(pText+iLen,m_aUnitName[iRow]))
				{
				dValue /= m_aUnitScale[iRow];
				}
			else for(iNum=0;iNum<ENTRIES(pUnitNames);iNum++)
				{
				if(pText[iLen]==*pUnitNames[iNum])
					{
					dValue *= UNIT_MIN*pow(10.0,iNum*3);
					dValue /= m_aUnitScale[iRow];
					break;
					}
				}
			}

		xsnprintf((TCHAR*)pText,pItem->item.cchTextMax,_T("%g"),dValue/m_aUnitScale[iRow]);
		UpdateSliders(iRow|0x8000);
		UpdateErros();
		iChg |=1;

		PostMessage(WM_COMMAND,ID_VARUPDATE);


		if(pItem->item.cChildren>1)						// Min-Max fr Skalen gendert
			{
			if(m_aComboRow[0]==iRow)iChg|=2;
			if(m_aComboRow[1]==iRow)iChg|=2;
			if(m_aComboRow[2]==iRow)iChg|=2;
			}
		}


	     if(iChg&2)UpdateCalculator();
	else if(iChg&1)OnValueChanged();

}

//*****************************************************************************
//*
//*		OnChangeNotify
//*
//*****************************************************************************
//	Wurde eine CheckBox verndert
void CMathViewerDlg::OnChangeNotify(NMHDR *pNmHdr,LRESULT *pResult)
{
NM_TREEVIEW *pNmTreeView = (NM_TREEVIEW*)pNmHdr;

int			 iBit;
int			 iRow;



    iBit	= (pNmTreeView->itemNew.state>>12)&1;
	iRow	=  m_cListWnd.GetRowOfItem(pNmTreeView->itemNew.hItem);

	if(!*pNmTreeView->itemNew.pszText && iBit)			// Leere Eintrge nicht setzen
		{
		m_cListWnd.SetItemCheckBox(pNmTreeView->itemNew.hItem,0);
		MessageBeep(MB_ICONERROR);
		return;
		}

	if(m_aComboRow[0]==iRow)m_cListWnd.SetItemCheckBox(pNmTreeView->itemNew.hItem,0);
	if(m_aComboRow[1]==iRow)m_cListWnd.SetItemCheckBox(pNmTreeView->itemNew.hItem,0);
	if(m_aComboRow[2]==iRow)m_cListWnd.SetItemCheckBox(pNmTreeView->itemNew.hItem,0);

	UpdateConst(iRow);
	UpdateEquations();
	UpdateErros();
	UpdateCalculator();
	UpdateValues();

	if(iBit!=m_cListWnd.GetItemCheckBox(pNmTreeView->itemNew.hItem))
		{
		MessageBeep(MB_ICONERROR);
		}

}

//*****************************************************************************
//*
//*		OnHScroll
//*
//*****************************************************************************
void CMathViewerDlg::OnHScroll(UINT nSbCode,UINT nPos,CScrollBar *pScrollBar)
{
double			dValue;
CSliderCtrl	   *pSlieder;
int				iSlider;
int				iChange;
int				iItem;
int				iPos;
int				iRow;



	if(pScrollBar==NULL)
		{
		return;
		}

	for(iSlider=0;iSlider<ENTRIES(m_aSlider);iSlider++)	// Suche den Slider
		{
		if(pScrollBar->m_hWnd==m_aSlider[iSlider]->m_hWnd)
			{
			break;
			}
		}

	if(iSlider>=ENTRIES(m_aSlider))
		{
		return;
		}


	if(iSlider<3)										// Welcher Slider wurde zuletzt benutzt
		{
		m_uLastUsed = iSlider;
		}

	pSlieder = m_aSlider[iSlider];
	iPos	 = pSlieder->GetPos();

	switch(nSbCode)
		{
	case SB_THUMBPOSITION:	iPos  = nPos;		break;
	case SB_THUMBTRACK:		iPos  = nPos;		break;
		}

	if(iPos<  0)iPos=0;
	if(iPos>100)iPos=100;

	   iRow	= m_aComboRow[iSlider];
	if(iRow<0)return;									// Welche Reihe ist betroffen

	if(iRow>=0 && m_aVarType[iRow]>=TYPE_EQUCONST)
		{
		if(m_aVarType[iRow]>TYPE_EQUCONST || !m_aVarSet[iRow])
			{
			if(nSbCode!=SB_THUMBPOSITION)
				{
				pSlieder->SetPos(iPos);
				return;
				}

			dValue  = m_aVarValue[iRow]-m_aVarMin[iRow];
			dValue /= m_aVarMax  [iRow]-m_aVarMin[iRow];
			dValue *= 100;

			if(dValue<  0.0)dValue=  0.0;
			if(dValue>100.0)dValue=100.0;

			m_aSlider[iSlider]->SetPos((int)dValue);	// Wert nicht vernderbar

			return;
			}
		}

	pSlieder->SetPos(iPos);

	   dValue = m_aVarMax[iRow]-m_aVarMin[iRow];
	if(dValue<=0.0)return;

	dValue /= 100.0;
	dValue *= iPos;
	dValue += m_aVarMin[iRow];
	iChange = (dValue!=GetValue(iRow,1))? 1:0;

	if(iChange)
		{
		SetValue(dValue,iRow,1);

		for(iItem=0;iItem<ENTRIES(m_aSlider);iItem++)	// Gleiche Slider nachziehen
			{
			if(iItem==iSlider)continue;
			if(iRow!=m_aComboRow[iItem])continue;
			m_aSlider[iItem]->SetPos(iPos);
			}

		OnValueChanged();
		UpdateValues();
		}

}

//*****************************************************************************
//*
//*		OnClick
//*
//*****************************************************************************
//	2D Auswahl gedrckt
void CMathViewerDlg::OnClick()
{
BOOL	bOld;
int		iRow;


	bOld = m_bSel2D;

	UpdateData();

	if(bOld!=m_bSel2D && (m_uOptions2D&CDR_3LINES))
		{
		if(!m_bSel2D)m_uOptions2D &= ~CDR_3LINES;
		ChangeLines();
		if(!m_bSel2D)m_uOptions2D |=  CDR_3LINES;
		}

	UpdateSliders();
	UpdateEquations();
	UpdateErros();
	UpdateCalculator();
	UpdateValues();

	if(!m_bSel2D)
		{
		SetDlgItemText(IDC_TEXTX,_T("X :"));
		SetDlgItemText(IDC_TEXTY,_T("Y :"));
		SetDlgItemText(IDC_TEXTZ,_T("Z :"));
		}
	else if(m_uOptions2D&CDR_3LINES)
		{
		SetDlgItemText(IDC_TEXTX,_T("Y1:"));
		SetDlgItemText(IDC_TEXTY,_T("Y2:"));
		SetDlgItemText(IDC_TEXTZ,_T("Y3:"));
		}
	else{
		SetDlgItemText(IDC_TEXTX,_T("X :"));
		SetDlgItemText(IDC_TEXTY,_T("Y1:"));
		SetDlgItemText(IDC_TEXTZ,_T("Y2:"));
		}

	m_cListWnd.SetColumnAutoEdit(5,TVAE_DBLCLICK|TVAE_FULLWIDTH|TVAE_CBLIST|TVAE_DROPDOWN,pScalaNames,(m_bSel2D)? ENTRIES(pScalaNames):2);


	for(iRow=0;iRow<MAX_VAR;iRow++)							// Umschalten der Markeranzeige
		{
		if(iRow>=(int)m_uVarListCnt)break;
		if(m_aVarMark[iRow]==0)continue;

		if(m_bSel2D)
				m_cListWnd.ListSetItemText(iRow,pScalaNames[m_aVarMark [iRow]+1],5);
		else	m_cListWnd.ListSetItemText(iRow,pScalaNames[m_aVarScala[iRow]  ],5);
		}



}

//*****************************************************************************
//*
//*		OnChange
//*
//*****************************************************************************
//	Hat sich der Text in den Formel verndert
void CMathViewerDlg::OnChange()
{

	m_uEquUpdate = 5;

}

//*****************************************************************************
//*
//*		OnTimer
//*
//*****************************************************************************
void CMathViewerDlg::OnTimer(UINT_PTR uIdEvent)
{
CPoint		sPoint;
BOOL		bMode;


	if(uIdEvent==ID_EQUTICK)
		{
		if(m_bIs2D && m_iXorOn)
			{
			bMode = (GetAsyncKeyState(VK_CONTROL)&0x8000)? 1:0;

			if(m_bMouseMode!=bMode)
				{
				GetCursorPos(&sPoint);
				m_cBitmapWnd.ScreenToClient(&sPoint);
				MouseCallback(WM_MOUSEMOVE,0,sPoint);
				}
			}

		if(!m_bDrawLock && m_bDrawReinit)
			{
			UpdateCalculator();
			}

		if(m_iXorOn)
			{
			GetCursorPos(&sPoint);
			m_cBitmapWnd.ScreenToClient(&sPoint);

			if(m_sXorPoint!=sPoint)
				{
				MouseCallback(WM_MOUSEMOVE,0,sPoint);
				}
			}


		if(m_uEquUpdate==0)return;

		   m_uEquUpdate--;
		if(m_uEquUpdate)return;

		UpdateEquations();
		UpdateErros();
		UpdateCalculator();
		UpdateValues();


		return;
		}


	CDialog::OnTimer(uIdEvent);
}

//*****************************************************************************
//*
//*		UpdateList
//*
//*****************************************************************************
//	Holt alle Variabelnamen und speichert sie in einer sortierten Liste
int	CMathViewerDlg::UpdateList()
{
int		iPos;


	m_sVarList.Del();									// Neue Variabelliste erstellen

	for(iPos=0;iPos<MAX_VAR;iPos++)
		{
		if(m_aVarName [iPos].IsEmpty())continue;
		if(m_aVarError[iPos])continue;
		m_sVarList.Add(m_aVarName[iPos],CSC_ABCG,&iPos);
		}


return 0;
}

//*****************************************************************************
//*
//*		UpdateSliders
//*
//*****************************************************************************
//	Alle Slider aktualisieren
//	iSlider		: Nummer des Sliders
//	Ergibt 0 wenn ok oder eine Fehlernummer
int CMathViewerDlg::UpdateSliders(int iSlider)
{
LPCTSTR			pName;
CString			sName;
double			dValue;
int				iCount;
int				iPos;
int				iSel;
int				iNum;
int				iRow;
int				iSet;


	if(iSlider<0)										// Alle Slider aktualisieren
		{
		for(iSlider=0;iSlider<ENTRIES(m_aSlider);iSlider++)
			{
			UpdateSliders(iSlider);
			}

		return 0;
		}


	if(iSlider>=ENTRIES(m_aSlider))
		{
		if(iSlider&0x8000)								// Fr eine bestimmte Reihe aktualisieren
			{
			iSlider &= 0x0FFF;

			for(iPos=0;iPos<ENTRIES(m_aSlider);iPos++)
				{
				if(iSlider^m_aComboRow[iPos])continue;
				UpdateSliders(iPos);
				}

			}

		return -1;
		}


	iCount = m_aCombo[iSlider]->GetCount();

	if(iCount>0)										// Prfe die ComboBox
		{
		iNum = -1;

		if(iCount-1==m_sVarList.Count())
			{
			for(iNum=1;iNum<iCount;iNum++)
				{
				m_aCombo[iSlider]->GetLBText(iNum,sName);
				if(sName!=m_sVarList[iNum-1])break;
				}
			}

		if(iNum<iCount)									// Gibt es nderungen
			{
			   iSel = m_aCombo[iSlider]->GetCurSel();
			if(iSel<=0)m_aComboTxt[iSlider]=_T("---");
			else{
				m_aCombo[iSlider]->GetLBText(iSel,m_aComboTxt[iSlider]);
				}

			m_aCombo[iSlider]->ResetContent();
			iCount = 0;
			}
		}

	if(iCount<=0)										// Combobox neu aufbauen
		{
		iSel = 0;
		m_aCombo[iSlider]->AddString(_T("---"));

		for(iPos=0;iPos<m_sVarList.Count();iPos++)
			{
			pName = m_sVarList[iPos];
			m_aCombo[iSlider]->AddString(pName);
			if(m_aComboTxt[iSlider]==pName)iSel=iPos+1;
			}

		m_aComboTxt[iSlider]=(iSel)? m_sVarList[iSel-1]:_T("---");
		m_aCombo   [iSlider]->SetCurSel(iSel);
		}


	iSet = 1;
														// Suche ausgewhlte Variable
	   iRow = m_sVarList.Find(m_aComboTxt[iSlider].GetLength(),m_aComboTxt[iSlider],0,-1,0x01);
	if(iRow>=0)
		{
		if(iSlider<3)
			{
			iRow = m_sVarList.DataGet(iRow);
			m_cListWnd.ListSetItemCheckBox(iRow,0);
			}
		else{
			iRow = m_sVarList.DataGet(iRow);
			if(iRow>=0 && m_aVarType[iRow]>=TYPE_EQUCONST)
			if(m_cListWnd.ListGetItemCheckBox(iRow)==0)
				{
				iSet = 0; 								// Wert wird von Variable berechnet
				}
			}
		}

	m_aComboRow[iSlider] = iRow;

	if(iRow>=0 && m_aVarMin[iRow]>=m_aVarMax[iRow])		// Gibt es einen Min/Max-Bereich
		{
		iRow = -1;
		}

	if(iRow>=0)
		{
		dValue  = m_aVarValue[iRow]-m_aVarMin[iRow];
		dValue /= m_aVarMax  [iRow]-m_aVarMin[iRow];
		dValue *= 100;

		if(dValue<  0.0)dValue=  0.0;
		if(dValue>100.0)dValue=100.0;

		m_aSlider[iSlider]->SetPos((int)dValue);
		}
	else{
		m_aSlider[iSlider]->SetPos(0);
		}

	if(iSlider==2)										// 2D oder 3D Zeichnung
		{
		m_bIs2D = (iRow<0 || m_bSel2D)? 1:0;
		}

	m_aSlider[iSlider]->EnableWindow(iRow>=0);



return 0;
}

//*****************************************************************************
//*
//*		UpdateUnit
//*
//*****************************************************************************
//	Die Einheit aktualisieren
//	uRow		: Zeile in der im Listenfenster mit den Variablen
//	pText		: Neuer Variabelnamen, bei NULL aus dem Listenfenster gehollen
//	Ergibt 1 wenn erfolgreich bzw. 0 bei einem Fehler
int CMathViewerDlg::UpdateUnit(UINT uRow,LPCTSTR pText)
{
TCHAR		cBuffer[64];
UINT		uOffset;
UINT		uIndex;
LPCTSTR		pName;
int			iInit;
int			iMax;
int			iNum;
int			iPos;
int			iLen;




	if(uRow>=MAX_VAR)return 0;

	if(!pText)													// Text von Fenster holen
		{
		iInit = 1;

			pText=m_cListWnd.ListGetItemText(uRow,0);
		if(!pText)
			{
			if(uRow>=MAX_VAR)return 0;
			m_aUnitName [uRow] = _T("");
			m_aVarName  [uRow] = _T("");
			m_aVarMin   [uRow] = 0.0;
			m_aVarMax   [uRow] = 0.0;
			m_aVarValue [uRow] = 0.0;
			m_aUnitScale[uRow] = 1.0;
			m_aVarIntern[uRow] = 0;
			return 0;
			}

		if(m_uVarListCnt<uRow && *pText)
			{
			m_uVarListCnt = uRow+1;
			}
		}
	else{
		iInit = 0;
		}

	pText += strwlen(pText,0xE0);								// Variabelnamen holen
	iNum   = strbits(pText,aAbcBits);
	if(strwchar(*pText,0x01))iNum=0;
	m_aVarName  [uRow].Format(_T("%.*s"),iNum,pText);
	m_aVarSet   [uRow] = m_cListWnd.ListGetItemCheckBox(uRow);
	m_aVarIntern[uRow] = TRUE;
	pText += iNum;
	iMax   = m_cListWnd.GetCount();


	if(m_aVarName[uRow].IsEmpty() || !iNum)						// Kein Variabelnamen
		{
		m_aVarError[uRow] = ((int)uRow+1<iMax)? 1:0;
		}
	else{
		for(iPos=0;iPos<ENTRIES(pReservedNames);iPos++)			// Auf reservierte Namen prfen
			{
				pName = pReservedNames[iPos];
			if(*pName!='*')
				{
				if(_tcsicmp(pName,m_aVarName[uRow]))
					{
					continue;
					}

				break;
				}

			pName++;
			iLen = strlen(pName);

			if(m_aVarName[uRow].GetLength()<=iLen)
				{
				continue;
				}

			if(_tcsnicmp(pName,m_aVarName[uRow],iLen))
				{
				continue;
				}

			if(strwchar(m_aVarName[uRow].GetAt(iLen),0x01))
				{
				break;
				}
			}

		if(iPos<ENTRIES(pReservedNames))						// Ist Wort reserviert
			{
			m_cListWnd.ListSetItemBkColor(uRow,0,(uRow&1)? RGB(255,200,200):RGB(255,220,220));
			m_aVarError[uRow] = 2;
			}
		else{
			m_aVarError[uRow] = 0;
			}
		}

	if(m_aVarError[uRow])										// Feld bei Fehlern einfrben
			m_cListWnd.ListSetItemBkColor(uRow,0,(uRow&1)? RGB(255,200,200):RGB(255,220,220));
	else	m_cListWnd.ListSetItemBkColor(uRow,0,TV_NOCOLOR);


	for(uIndex=0;uIndex<MAX_VAR;uIndex++)						// Prfe doppete Namen
		{
		if(m_aVarName[uIndex].IsEmpty())continue;

		pName = m_aVarName[uIndex];

		for(uOffset=uIndex+1;uOffset<MAX_VAR;uOffset++)
			{
			if(m_aVarError[uOffset])continue;
			if(m_aVarName [uOffset].IsEmpty())continue;
			if(m_aVarName [uOffset].CompareNoCase(pName))continue;

			m_aVarError[uOffset] = 3;
			m_cListWnd.ListSetItemBkColor(uOffset,0,(uOffset&1)? RGB(255,200,200):RGB(255,220,220));
			}

		for(uOffset=0;uOffset<uIndex;uOffset++)					// Prfe doppete Namen
			{
			if(m_aVarName[uOffset].IsEmpty())continue;
			if(m_aVarName[uOffset].CompareNoCase(pName))continue;
			break;
			}

		if(m_aVarError[uIndex]==3 && uOffset>=uIndex)
			{
			m_aVarError[uOffset] = 0;
			m_cListWnd.ListSetItemBkColor(uIndex,0,TV_NOCOLOR);
			}
		}


		pText += strchar(pText,'[');							// Einheit holen
	if(*pText)
		{
		pText+=1;
		pText+=strwlen(pText,0xE0);
		}

	strlcpy(cBuffer+1,pText,ENTRIES(cBuffer)-8,strchar(pText,']'));
	strcut (cBuffer+1);
	if(iInit)m_aUnitName[uRow]=cBuffer+1;

	pName = m_cListWnd.ListGetItemText(uRow,4);
	iNum  = 255;

	if(!_tcscmp(pName+1,m_aUnitName[uRow]))						// Suche Prfix
		{
		for(iNum=0;iNum<ENTRIES(pUnitNames);iNum++)
			{
			if(pName[0]==*pUnitNames[iNum])
				{
				break;
				}
			}

		m_aUnitScale[uRow] = UNIT_MIN*pow(10.0,iNum*3);
		}
	else{
		m_aUnitScale[uRow] = 1.0;
		}

	if(!iInit)m_aUnitName[uRow]=cBuffer+1;


	if(iNum<ENTRIES(pUnitNames))
			pName = pUnitNames[iNum];
	else	pName = _T("");

																// Einheitentext setzen
	cBuffer[0]    = *pName;
	m_cListWnd.ListSetItemText(uRow,(cBuffer[0])? cBuffer:cBuffer+1,4);



return 1;
}

//*****************************************************************************
//*
//*		UpdateErros
//*
//*****************************************************************************
//	Fehler fr die Zeichnung aktualisieren
int CMathViewerDlg::UpdateErros()
{
BOOL		aErr[MAX_VAR];
LPCTSTR		pName;
UINT		uLast;
int			iPos;
int			iRow;
int			iNum;
int			iMax;


	for(iRow=0;iRow<MAX_VAR;iRow++)								// Alte  Min/Max Fehler sichern
		{
		aErr[iRow] = 0;
		}


	iMax	 = (m_aComboRow[2]<0)? 2:3;
	uLast	 =  m_uError;
	m_uError =  0;


	if(m_uErrorChg)												// Hat sich der Fehlertext verndert
		{
		uLast ^= rand();
		m_uErrorChg = 0;
		}

	for(iPos=0;iPos<3;iPos++)									// Prfe Min/Max Bereiche
		{
		   iRow = m_aComboRow[iPos];
		if(iRow<0)continue;

		if(m_aVarMax[iRow]>m_aVarMin[iRow])continue;

		m_sError.Format(_T("Ungltiger Min/Max Bereich bei '%s' fr die %c-Richtung !"),m_aVarName[iRow],'X'+iPos);
		SetDlgItemText(IDC_TEXT,m_sError);
		m_uError   = 4+iPos;
		aErr[iRow] = 1;
		}

	for(iRow=0;iRow<MAX_VAR;iRow++)								// Prfe Min/Max Bereiche
		{
		if(m_aVarName[iRow].IsEmpty())continue;
		if(m_aVarMax [iRow]>m_aVarMin[iRow])continue;
		aErr[iRow] = 1;
		}

	for(iPos=0;iPos<3;iPos++)									// Prfe Min/Max Bereiche
		{
		   iRow = m_aComboRow[iPos];
		if(iRow<0)continue;

		if(m_aVarScala[iRow]==0)continue;
		if(m_aVarMax[iRow]>0.0 && m_aVarMin[iRow]>0.0)continue;

		m_sError.Format(_T("Falscher logarithmischer Min/Max Bereich bei '%s' fr die %c-Richtung !"),m_aVarName[iRow],'X'+iPos);
		SetDlgItemText(IDC_TEXT,m_sError);
		m_uError   = 8+iPos;
		aErr[iRow] = 2;
		}

	for(iRow=0;iRow<MAX_VAR;iRow++)								// nderungen bei Min/Max Fehlern
		{
		if(aErr[iRow]==m_aMinMaxErr[iRow])continue;
		m_aMinMaxErr[iRow] = aErr[iRow];
		pName	= m_cListWnd.ListGetItemText(iRow);

		if(m_aMinMaxErr[iRow] && pName && *pName)
			{	m_cListWnd.ListSetItemBkColor(iRow,2,(iRow&1)? RGB(255,200,200):RGB(255,220,220));
				m_cListWnd.ListSetItemBkColor(iRow,3,(iRow&1)? RGB(255,200,200):RGB(255,220,220));}
		else{	m_cListWnd.ListSetItemBkColor(iRow,2,TV_NOCOLOR);
				m_cListWnd.ListSetItemBkColor(iRow,3,TV_NOCOLOR);}
		}


	for(iPos=0;iPos<3;iPos++)									// ComboBoxFehler lschen
		{
		aErr[iPos] = 0;
		}

	for(iPos=0;iPos<3;iPos++)									// Auf doppelte Auswahl prfen
		{
		   iRow = m_aComboRow[iPos];
		if(iRow<0)continue;

		for(iNum=iPos+1;iNum<iMax;iNum++)
			{
			if(iRow!=m_aComboRow[iNum])continue;
			m_sError.Format(_T("%c-Richtung und %c-Richtung benutzen die gleiche Variable '%s' !"),'X'+iPos,'X'+iNum,m_aVarName[iRow]);
			m_uError   = 7+iPos;
			aErr[iPos] = 1;
			aErr[iNum] = 1;
			}
		}

	for(iPos=0;iPos<iMax;iPos++)								// Achsen Auswahl prfen
		{
		   iRow = m_aComboRow[iPos];
		if(iRow>=0)continue;

		m_sError.Format(_T("Keine Variable fr die %c-Richtung ausgewhlt !"),'X'+iPos);
		m_uError   = 1+iPos;
		aErr[iPos] = 1;
		}


	for(iPos=0;iPos<3;iPos++)									// nderungen bei ComboBox-Fehlern
		{
		if(aErr[iPos]==m_aComboErr[iPos])continue;
		m_aComboErr[iPos] = aErr[iPos];
		m_aCombo   [iPos]->RedrawWindow();
		}


	if(!m_uError && m_uEquErrors)
		{
		m_uError = m_uEquErrors|0x800;

		switch(m_uEquErrors)
			{
		case  0:																															break;
		case  1:m_sError.Format(_T("Es wurden zuviele Formeln definiert !"));																break;
		case  2:m_sError.Format(_T("Die Variable '%s' enhlt ungltige Zeichen !")								,(LPCTSTR)m_sEquErrText);	break;
		case  3:m_sError.Format(_T("Keine Formel bei '%s' !")                     								,(LPCTSTR)m_sEquErrText);	break;
		case  4:m_sError.Format(_T("Keine Variable bei '%s' !")						  							,(LPCTSTR)m_sEquErrText);	break;
		case  5:m_sError.Format(_T("Es wurde keine Formel gefunden !"));																	break;
		case  6:m_sError.Format(_T("Die Variabel '%s' kann nicht berechnet werden !")							,(LPCTSTR)m_sEquErrText);	break;
		case  7:m_sError.Format(_T("Syntaxfehler in Formel bei '%s' !")											,(LPCTSTR)m_sEquErrText);	break;
		case  8:m_sError.Format(_T("Rekursive Formel %s !")														,(LPCTSTR)m_sEquErrText);	break;
		case  9:m_sError.Format(_T("Zuviele zustzliche Variablen in den Formeln  !"));														break;
		case 10:m_sError.Format(_T("Es fehlt eine Berechung fr '%s' !")										,(LPCTSTR)m_sEquErrText);	break;
		case 11:m_sError.Format(_T("Formel fr '%s' ist doppelt definiert !")									,(LPCTSTR)m_sEquErrText);	break;
		case 12:m_sError.Format(_T("Die Laufvariable '%s' ist in einer Formel definiert  !")					,(LPCTSTR)m_sEquErrText);	break;
		case 13:m_sError.Format(_T("Die Variable '%s' ist mehrfach fr die Ausgabe ausgewhlt !")				,(LPCTSTR)m_sEquErrText);	break;
		case 14:m_sError.Format(_T("Die Variable '%s' ist fr die Ausgabe und als Laufvariable ausgewhlt !")	,(LPCTSTR)m_sEquErrText);	break;
		case 15:m_sError.Format(_T("Die Variable '%s' ist fr mehr als eine Koordinate ausgewhlt !")			,(LPCTSTR)m_sEquErrText);	break;
		case 16:m_sError.Format(_T("Die Formel fr '%s' kann nicht berechnet werden !")							,(LPCTSTR)m_sEquErrText);	break;
		default:m_sError.Format(_T("Unbekanter Fehler %i !")													,         m_uEquErrors );	break;
			}
		}

	if(m_uError!=uLast)
		{
		if(!m_uError)m_sError.Empty();
		m_sError.Format(m_sError);
		SetDlgItemText(IDC_TEXT,m_sError);
		}


return 0;
}


//*****************************************************************************
//*
//*		OnSave
//*
//*****************************************************************************
//	Aktuelle Daten speichern
void CMathViewerDlg::OnSave()
{
CString			sPath;
CString			sText;
FILE		   *pFile;
int				iPos;
int				iMax;


	CFileDialog	sDlg(FALSE,_T("*.mvi"),sPath,OFN_EXPLORER|OFN_ENABLESIZING|OFN_PATHMUSTEXIST|OFN_HIDEREADONLY,"MathViewer-Dateien (*.mvi)|*.mvi|Textdateien (*.txt)|*.txt|Alle Dateien      (*.*)|*.*|");

	if(sDlg.DoModal()!=IDOK)return;

	sPath = sDlg.GetPathName();

	if(ExistFile(sPath))
		{
		sText.Format(_T("Die Datei %s existiert bereits !\n\nSoll sie berschreiben werden ?"),(LPCSTR)sPath);
		if(MessageBox(sText,_T("Warnung"),MB_YESNO|MB_ICONWARNING)!=IDYES)return;
		}

		pFile = _tfopen(sPath,"wb");
	if(!pFile)
		{
		sText.Format(_T("Die Datei %s konnte nicht geffnet werden !"),(LPCSTR)sPath);
		MessageBox(sText,_T("Fehler"),MB_OK|MB_ICONERROR);
		return;
		}


	UpdateData();

	fprintfa(pFile,_T("MVIFILE\n\n"));

	fprintfa(pFile,_T("Select2D    = %i\n"    ),m_bSel2D);
	fprintfa(pFile,_T("Options2D   = 0x%08X\n"),m_uOptions2D);
	fprintfa(pFile,_T("Options3D   = 0x%08X\n"),m_uOptions3D);
	fprintfa(pFile,_T("RollX       = %f\n"    ),m_sParams3D.dRollX);
	fprintfa(pFile,_T("RollY       = %f\n"    ),m_sParams3D.dRollY);
	fprintfa(pFile,_T("RollZ       = %f\n"    ),m_sParams3D.dRollZ);
	fprintfa(pFile,_T("Zoom        = %f\n"    ),m_sParams3D.dZoom);
	fprintfa(pFile,_T("Look        = %f\n"    ),m_sParams3D.dLook);
	fprintfa(pFile,_T("Shadow      = %f\n"    ),m_sParams3D.dShadow);
	fprintfa(pFile,_T("ShadowPlane = %f\n\n"  ),m_sParams3D.iShadowPlane);
	fprintfa(pFile,_T("TempSelX    = %s\n"    ),(LPCTSTR)m_sTempTextX);
	fprintfa(pFile,_T("TempSelY3   = %s\n"    ),(LPCTSTR)m_sTempTextY3);

	for(iPos=0;iPos<ENTRIES(m_aComboTxt);iPos++)
		{
		fprintfa(pFile,_T("Select%i = %s\n"),iPos,(LPCTSTR)m_aComboTxt[iPos]);
		}

	fprintfa(pFile,_T("\n"),m_sParams3D.iShadowPlane);

	iMax = m_cListWnd.GetCount()-1;

	for(iPos=0;iPos<MAX_VAR && iPos<iMax;iPos++)
		{
		fprintfa(pFile,_T("Variable = \"%s\" \"%s\" \"%s\" \"%s\" \"%s\" \"%s\" %i\n"),
				m_cListWnd.ListGetItemText(iPos,0),
				m_cListWnd.ListGetItemText(iPos,1),
				m_cListWnd.ListGetItemText(iPos,2),
				m_cListWnd.ListGetItemText(iPos,3),
				m_cListWnd.ListGetItemText(iPos,4),
				m_cListWnd.ListGetItemText(iPos,5),
				m_cListWnd.ListGetItemCheckBox(iPos));
		}

	fprintfa(pFile,_T("\nFormular\n%s"),(LPCTSTR)m_sFormular);
	fclose(pFile);

}

//*****************************************************************************
//*
//*		OnLoad
//*
//*****************************************************************************
//	Daten aus Datei laden
void CMathViewerDlg::OnLoad()
{
CString			sPath;
CString			sText;
unsigned		uFlag;
unsigned		uRet;



	uFlag = (m_bLoadOption)? OFN_READONLY:0;

	CFileDialog	sDlg(TRUE,_T("*.mvi"),sPath,OFN_EXPLORER|OFN_ENABLESIZING|OFN_PATHMUSTEXIST|OFN_RENAMERO|uFlag,_T("Optionen laden@MathViewer-Dateien (*.mvi)|*.mvi|Textdateien (*.txt)|*.txt|Alle Dateien      (*.*)|*.*|"));

	if(sDlg.DoModal()!=IDOK)return;

	m_bLoadOption = sDlg.GetReadOnlyPref();
	sPath		  = sDlg.GetPathName();

	if(ExistFile(sPath)!=1)
		{
		sText.Format(_T("Die Datei %s konnte nicht gefunden werden !"),(LPCSTR)sPath);
		MessageBox(sText,_T("Fehler"),MB_OK|MB_ICONERROR);
		return;
		}

	   uRet = Load(sPath,m_bLoadOption);
	if(uRet==1)
		{
		sText.Format(_T("Die Datei %s konnte nicht geffnet werden !"),(LPCSTR)sPath);
		MessageBox(sText,_T("Fehler"),MB_OK|MB_ICONERROR);
		return;
		}

	if(uRet==2)
		{
		sText.Format(_T("Die Datei %s hatte ein falsches Format !"),(LPCSTR)sPath);
		MessageBox(sText,_T("Fehler"),MB_OK|MB_ICONERROR);
		return;
		}

}

//*****************************************************************************
//*
//*		Load
//*
//*****************************************************************************
//	Ld eine Konfiguration aus einer Datei
//	pPath			: Ist der Dateiname
//	bObtions		: Auch die Optionen laden
//	Ergibt 0 wenn ok, 1 wenn die Datei nicht gefunden wurde bzw. 2 bei einem Formatfehler
int	CMathViewerDlg::Load(LPCSTR pPath,BOOL bObtions)
{
TCHAR			cBuffer[1024];
TCHAR			cName[256];
UINT			uOptions;
LPCTSTR			pText;
CFileBuffer		sFile;
BOOL			bForm;
HTREEITEM		hItem;
int				iPos;
int				iNum;
int				iVar;
int				iVal;




	if(!sFile.Open(pPath))return 1;


	if(sFile.ReadLine(cBuffer,ENTRIES(cBuffer))<0)
		{
		cBuffer[0]=0;
		}

	strgetstr(cName,cBuffer,ENTRIES(cName));


	if(stricmp(cName,"MVIFILE"))							// Prfe das Format
		{
		return 2;
		}


	iVar		= 0;
	bForm		= FALSE;
	uOptions	= 0x0000;
	m_sFormular = _T("");
	m_cListWnd.DeleteAllItems();
	cBuffer[ENTRIES(cBuffer)-1]=0;

	for(iPos=0;iPos<MAX_VAR;iPos++)
		{
		m_aVarMin    [iPos] = 0.0;
		m_aVarMax    [iPos] = 0.0;
		m_aVarValue  [iPos] = 0.0;
		m_aUnitScale [iPos] = 1.0;
		m_aMinMaxErr [iPos] = 0;
		m_aVarError  [iPos] = 0;
		m_aVarMinOk  [iPos] = 0;
		m_aVarMaxOk  [iPos] = 0;
		m_aVarValueOk[iPos] = 0;
		m_aVarScala  [iPos] = 0;
		}

	for(iPos=0;iPos<ENTRIES(m_aComboRow);iPos++)
		{
		m_aComboErr[iPos] =  0;
		m_aComboRow[iPos] = -1;
		}


	while(sFile.ReadLine(cBuffer,ENTRIES(cBuffer))>=0)
		{
		iPos  = strgetstr(cName,cBuffer,ENTRIES(cName));
		iPos +=	strwlen  (cBuffer+iPos,0xE0);

		if(cBuffer[iPos]=='=')
			{
			iPos++;

			if(            !_tcscmp (cName,_T("Select2D"	))){m_bSel2D				 = strtoi(cBuffer+iPos+1       );continue;}
			if(			   !_tcscmp (cName,_T("Options2D"	))){  uOptions  			 = strtoi(cBuffer+iPos+1       );continue;}
			if(bObtions && !_tcscmp (cName,_T("Options2D"	))){m_uOptions2D			 = strtoi(cBuffer+iPos+1       );continue;}
			if(bObtions && !_tcscmp (cName,_T("Options3D"	))){m_uOptions3D			 = strtoi(cBuffer+iPos+1       );continue;}
			if(bObtions && !_tcscmp (cName,_T("RollX"		))){m_sParams3D.dRollX		 = strtof(cBuffer+iPos+1,0,0x07);continue;}
			if(bObtions && !_tcscmp (cName,_T("RollY"		))){m_sParams3D.dRollY		 = strtof(cBuffer+iPos+1,0,0x07);continue;}
			if(bObtions && !_tcscmp (cName,_T("RollZ"     	))){m_sParams3D.dRollZ		 = strtof(cBuffer+iPos+1,0,0x07);continue;}
			if(bObtions && !_tcscmp (cName,_T("Zoom"      	))){m_sParams3D.dZoom		 = strtof(cBuffer+iPos+1,0,0x07);continue;}
			if(bObtions && !_tcscmp (cName,_T("Look"      	))){m_sParams3D.dLook		 = strtof(cBuffer+iPos+1,0,0x07);continue;}
			if(bObtions && !_tcscmp (cName,_T("Shadow"    	))){m_sParams3D.dShadow		 = strtof(cBuffer+iPos+1,0,0x07);continue;}
			if(bObtions && !_tcscmp (cName,_T("ShadowPlane"	))){m_sParams3D.iShadowPlane = strtoi(cBuffer+iPos+1       );continue;}

			if(!_tcscmp(cName,_T("TempSelX")))
				{
				strgetstr(cName,cBuffer+iPos,ENTRIES(cName));
				m_sTempTextX = cName;
				}

			if(!_tcscmp(cName,_T("TempSelY3")))
				{
				strgetstr(cName,cBuffer+iPos,ENTRIES(cName));
				m_sTempTextY3 = cName;
				}

			if(!_tcsncmp(cName,_T("Select"),6) && cName[6]>='0' && cName[6]<'9')
				{
				   iNum=_ttoi(cName+6);
				if(iNum<ENTRIES(m_aCombo))
					{
					strgetstr(cName,cBuffer+iPos,ENTRIES(cName));
					m_aComboTxt[iNum] = cName;
					m_aCombo   [iNum]->ResetContent();
					}

				continue;
				}

			if(!_tcscmp(cName,_T("Variable")) && iVar<MAX_VAR)
				{
				iPos +=	strgetstr(cName,cBuffer+iPos,ENTRIES(cName));
				hItem = m_cListWnd.InsertItem(cName);
				iPos +=	strgetstr(cName,cBuffer+iPos,ENTRIES(cName));
				m_cListWnd.SetItemText(hItem,cName,1);
				iPos +=	strgetstr(cName,cBuffer+iPos,ENTRIES(cName));
				m_cListWnd.SetItemText(hItem,cName,2);
				iPos +=	strgetstr(cName,cBuffer+iPos,ENTRIES(cName));
				m_cListWnd.SetItemText(hItem,cName,3);
				iPos +=	strgetstr(cName,cBuffer+iPos,ENTRIES(cName));
				m_cListWnd.SetItemText(hItem,cName,4);
				iPos +=	strgetstr(cName,cBuffer+iPos,ENTRIES(cName));
				m_cListWnd.SetItemText(hItem,cName,5);
				iPos +=	strgetstr(cName,cBuffer+iPos,ENTRIES(cName));
				m_cListWnd.SetItemCheckBox(hItem,atoi(cName));
				iVar++;
				}

			m_uVarListCnt = m_cListWnd.GetRowCount();

			if(m_uVarListCnt>0)
				{
				pText = m_cListWnd.ListGetItemText(m_uVarListCnt);
				if(!pText || !*pText)m_uVarListCnt--;
				}

			continue;
			}

		if(!_tcscmp(cName,_T("Formular")))
			{
			bForm=1;
			break;
			}
		}


	
	if((uOptions^m_uOptions2D)&CDR_3LINES)				// Auswahl fr 3 Linien anpassen
		{
		m_uOptions2D ^= CDR_3LINES;
		}


	if(bForm)
		{
		while(sFile.ReadLine(cBuffer,ENTRIES(cBuffer))>=0)
			{
			m_sFormular += cBuffer;
			m_sFormular += "\r\n";
			}
		}

	m_uVarListCnt = m_cListWnd.GetRowCount();
	m_cListWnd.InsertItem("");

	for(iPos=0;iPos<(int)m_uVarListCnt;iPos++)			// Marker und Skalierung auswerten
		{
			pText = m_cListWnd.ListGetItemText(iPos,5);
		if(!pText)break;

		for(iVal=ENTRIES(pScalaNames)-1;iVal>0;iVal--)
			{
			if(!_tcsicmp(pText,pScalaNames[iVal]))break;
			}

		if(iVal<2)
			{
			m_aVarScala[iPos] = iVal;
			}
		else{
			m_aVarScala[iPos] = 0;
			}
		}

	for(iPos=0;iPos<iVar;iPos++)
		{
		UpdateUnit(iPos);
		GetValue(iPos,1);
		GetValue(iPos,2);
		GetValue(iPos,3);
		GetValue(iPos,5);
		}

	UpdateData(FALSE);
	UpdateList();
	UpdateSliders();
	UpdateEquations();
	UpdateErros();
	UpdateCalculator();
	UpdateValues();
	OnClick();


return 0;
}

//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void CMathViewerDlg::OnOK()
{

	UpdateData();


	if(m_bSel2D)
			Draw2D();
	else	Draw3D();

}

//*****************************************************************************
//*
//*		TokenCallback
//*
//*****************************************************************************
//	Sucht nach der Variable fr ein Token
//	pText		: Zeiger auf Tokenname
//	pValue		: Hier wird die Variabelwert gespeichert
//	pVarNumber	: Hier wird die Variabelnummer gespeichert
//	Ergibt die Lnge des Tokens, bzw 0 wenn das Token nicht gefunden wurde
int _cdecl CMathViewerDlg::TokenCallback(void *pParam,const char *pText, double *pValue,unsigned *pVarNumber){return ((CMathViewerDlg*)pParam)->TokenCallback(pText,pValue,pVarNumber);}
int        CMathViewerDlg::TokenCallback(             const char *pText, double *pValue,unsigned *pVarNumber)
{
int		iLen;
int		iVar;


	if(strwchar(*pText,0x01))return 0;

		iLen=strbits(pText,aAbcBits);
	if(!iLen)return 0;

	   iVar = m_sVarList.FindFast(iLen,pText);
	if(iVar>=0)											// Wurde die Variable gefunden
		{	
		*pVarNumber = m_sVarList.DataGet(iVar);
		return iLen;
		}

	
	m_sEquErrText.Format(_T("%.*s"),iLen,pText);
	m_uEquErrors = 6;
	
	
return 0;
}

//*****************************************************************************
//*
//*		UpdateConst
//*
//*****************************************************************************
//	iVar	: Ist die Variabelnummer die gedrckt wurde.
void CMathViewerDlg::UpdateConst(UINT uRow)
{
int		iFound;



	if(uRow>=MAX_VAR)return;
	if(m_aVarName[uRow].IsEmpty())return;

	m_aVarSet[uRow] = m_cListWnd.ListGetItemCheckBox(uRow);
	m_uClickNr++;

	   iFound = m_sVarClick.FindFast(m_aVarName[uRow]);
	if(iFound>=0)
		{
		m_sVarClick.DataSet(iFound,m_uClickNr);
		}
	else{
		m_sVarClick.Add(m_aVarName[uRow],CSC_ABC,&m_uClickNr);
		}




}

//*****************************************************************************
//*
//*		CheckConst
//*
//*****************************************************************************
//	Prft eine Variable als Vorgabe benutzt werden kann
//	uNeed		: Bitfeld mit Variablen die bentigt werden
//	uLock		: Bitfeld mit Variablen die niczt benutzt werden drfen
//	uConst		: Bitfeld mit Variablen die Konstanten oder Vorgaben sind
//	uUsed		: Hier werden die benutzden Variablen gespeichert
//	Ergibt 1 wenn die Formel als Vorgabe benutzt werden darf
int	CMathViewerDlg::CheckConst(BitSet uNeed,BitSet uLock,BitSet uConst,BitSet &uUsed)
{
UINT			aMyEqu [MAX_EQU];
BitSet			aMyUse [MAX_EQU];
BitSet			aMyNeed[MAX_EQU];
BitSet			aMyDone[MAX_EQU];
BitSet			uUse;
UINT			uLevel;
UINT			uPos;
int				iVar;


	uNeed  &= ~uConst;

	if(!uNeed)return 1;

	uPos	=  m_uEquCount;
	uUse	=  0;
	uLevel	=  0;

	for(;;)														// Formeln prfen
		{
		if(!uPos)												// Pfad ging ins Leere
			{
			if(!uLevel)break;									// Gibt es weiter ste

			uLevel--;

			uPos	= aMyEqu [uLevel];							// Nchsten Ast probieren
			uUse	= aMyUse [uLevel];
			uNeed	= aMyNeed[uLevel];
			uLock	= aMyDone[uLevel];

			continue;
			}


		uPos--;

		iVar = m_aEquResVar[uPos];

		if(bit_read(&uNeed,iVar)==0)continue;					// Wird das Ergebnis der Formel gebraucht
		if(bit_read(&uLock,iVar)!=0)continue;					// Wurde das Ergebnis schon verwendet
		if(m_aEquDepend[uPos]&uLock)continue;					// Verwendet die Formel gesperrte Variablen
		if(uLevel>MAX_EQU-2)continue;

		aMyEqu [uLevel] = uPos;
		aMyUse [uLevel] = uUse;
		aMyNeed[uLevel] = uNeed;
		aMyDone[uLevel] = uLock;

		uNeed |= m_aEquDepend[uPos]&~uConst;

		bit_clear(&uNeed ,iVar);
		bit_set  (&uLock ,iVar);
		bit_set  (&uUse  ,iVar);


		if(!uNeed)												// Alles gefunden
			{
			uUsed |= uUse;
			return 1;
			}

		uPos	= m_uEquCount;
		uLevel += 1;
		}



return 0;
}

//*****************************************************************************
//*
//*		UpdateValues
//*
//*****************************************************************************
//	Aktualisiert alle Variablen in der Liste
int	CMathViewerDlg::UpdateValues()
{
double		aValues[MAX_VAR];
double		dValue;
unsigned	uColor;
int			iCount;
int			iItem;
int			iRow;



	iCount = CalcValues(aValues);


 	for(iRow=0;iRow<MAX_VAR;iRow++)								// Variabelwerte schreiben
		{
		if(iRow>=(int)m_uVarListCnt)break;

		uColor	= m_aVarColor[iRow];

		if(m_aVarType[iRow]<TYPE_EQUCONST || m_aVarSet[iRow])
			{
			m_cListWnd.ListSetItemTextColor(iRow,1,uColor);
			m_cListWnd.ListSetItemState(iRow,1,0,TVIS_UNDERLINE);
			continue;
			}

		m_cListWnd.ListSetItemTextColor(iRow,1,uColor);
		m_cListWnd.ListSetItemState(iRow,1,TVIS_UNDERLINE,TVIS_UNDERLINE);

		SetValue(aValues[iRow],iRow,1,1);
		m_aVarValue[iRow] = aValues[iRow];

		for(iItem=0;iItem<ENTRIES(m_aSlider);iItem++)			// Slider nachziehen
			{
			if(iRow!=m_aComboRow[iItem])continue;

			dValue  = m_aVarValue[iRow]-m_aVarMin[iRow];
			dValue /= m_aVarMax  [iRow]-m_aVarMin[iRow];
			dValue *= 100;

			if(dValue<  0.0)dValue=  0.0;
			if(dValue>100.0)dValue=100.0;

			m_aSlider[iItem]->SetPos((int)dValue);
			}
		}



return iCount;
}

//*****************************************************************************
//*
//*		CalcValues
//*
//*****************************************************************************
//	Berechnet alle Variablen in der Liste
int CMathViewerDlg::CalcValues(double *pValues,BitSet uIgnore)
{
double		dValue;
int			iCount;
int			iPos;
int			iEqu;
int			iRow;
int			iOk;

		  


 	for(iRow=0;iRow<(int)m_uVarCount;iRow++)					// Variabelwerte holen
		{
		if(bit_read(&uIgnore,iRow))
			{
			continue;
			}

		pValues[iRow] = m_aVarValue[iRow];
		}

	iCount = 0;


	if(m_uConstEquCnt)											// Konstante Formeln berechnen
		{
		iOk = 1;

		for(iPos=0;iPos<(int)m_uConstEquCnt;iPos++)				// Formeln abarbeiten
			{
			iEqu   = m_aConstEquList[iPos];
			iRow   = m_aEquResVar   [iEqu];

			CalcSetValues(m_aConstEqu+iPos,pValues,m_uDrawVarCnt);
			dValue = CalcExecute(m_aConstEqu+iPos,&iOk);

			if(iRow>=0)pValues[iRow]=dValue;
			iCount++;
			}
		}

	if(m_uDrawEquCnt)											// Werte berechnen
		{
		iOk = 1;

		for(iPos=0;iPos<(int)m_uDrawEquCnt;iPos++)				// Formeln abarbeiten
			{
			iEqu   = m_aDrawEquList[iPos];
			iRow   = m_aEquResVar  [iEqu];

			CalcSetValues(m_aDrawEqu+iPos,pValues,m_uDrawVarCnt);
			dValue = CalcExecute(m_aDrawEqu+iPos,&iOk);

			if(iRow>=0)pValues[iRow]=dValue;
			iCount++;
			}
		}

	if(m_uPostEquCnt)											// Formeln am Ende berechnen
		{
		iOk = 1;

		for(iPos=0;iPos<(int)m_uPostEquCnt;iPos++)				// Formeln abarbeiten
			{
			iEqu   = m_aPostEquList[iPos];
			iRow   = m_aEquResVar  [iEqu];

			CalcSetValues(m_aPostEqu+iPos,pValues,m_uDrawVarCnt);
			dValue = CalcExecute(m_aPostEqu+iPos,&iOk);
			
			if(iRow>=0)pValues[iRow]=dValue;
			iCount++;
			}
		}


return iCount;
}


//*****************************************************************************
//*
//*		UpdateEquations
//*
//*****************************************************************************
//	Dekotiert die Formeln aus dem Fenster
int	CMathViewerDlg::UpdateEquations()
{
TCHAR		cVarName[256];
UINT		uLastErr;
CString		sTextTxt;
HTREEITEM	hItem;
LPCTSTR		pLast;
LPCTSTR		pText;
LPCTSTR		pBase;
CString		sText;
UINT		uPos;
int			iLen;
int			iIdx;
int			iVar;
int			iNum;
int			iRow;
int			iEnd;
int			iOk;



	m_uVarList		= 0;										// Variablen die im Listenfenster stehen
	m_uVarConst		= 0;										// Variablen fr die Konstant sind
	m_uVarFixed		= 0;										// Variablen die via ComboBox fixiert sind oder im Listenfenster als Vorgabe
	m_uVarCombo		= 0;										// Variablen die via ComboBox fixiert sind als Vorgabe
	m_uVarInput		= 0;										// Laufvariablen die (X/Y) aus dem Listenfenster
	m_uVarOutput	= 0;										// Ergebnis die (Z,Y1,Y2,Y3) aus dem Listenfenster
	m_uVarResult	= 0;										// Variablen fr die es eine Formel gibt



	for(uPos=0;uPos<MAX_VAR;uPos++)								// Wievile Variablen sind im Listenfenster definiert
		{
		if(!m_aVarIntern[uPos])break;
		
		m_aVarSet    [uPos] =  0;
		m_aVarMark   [uPos] =  0;
		m_aVarEqation[uPos] = -1;
		bit_set(&m_uVarList,uPos);

		hItem = m_cListWnd.GetItemOfRow(uPos);

		if(hItem && m_cListWnd.GetCheck(hItem))					// Als Vorgabe markiert
			{
			m_aVarSet[uPos] = 1;
			bit_set(&m_uVarFixed,uPos);
			}
		}

	m_uVarListCnt = uPos;	
	m_uVarCount   = uPos;

	for(uPos=m_uVarCount;uPos<MAX_VAR;uPos++)					// Die unbenutzen Pltze lschen
		{
		m_aUnitName  [uPos].Empty();						
		m_aVarName   [uPos].Empty();						
		m_aVarColor  [uPos] = 0;
		m_aVarMin    [uPos] = 0;
		m_aVarMax    [uPos] = 0;
		m_aVarValue  [uPos] = 0;
		m_aUnitScale [uPos] = 0;
		m_aVarError  [uPos] = 0;
		m_aVarMinOk  [uPos] = 0;
		m_aVarMaxOk  [uPos] = 0;
		m_aVarValueOk[uPos] = 0;
		m_aVarSet    [uPos] = 0;
		m_aVarIntern [uPos] = 0;
		m_aMinMaxErr [uPos] = 0;
		m_aVarScala  [uPos] = 0;
		m_aVarMark   [uPos] = 0;
		m_aVarSet	 [uPos] = 0;
		m_aVarEqation[uPos] =-1;
		}

	
	for(uPos=3;uPos<MAX_COMBO;uPos++)							// Welche Variablen wird via Combo-Boxen vorgegeben
		{
		   iRow = m_aComboRow[uPos];
		if(iRow<0)continue;
		
		bit_set(&m_uVarFixed,iRow);
		bit_set(&m_uVarCombo,iRow);
		
		m_aVarSet[iRow] = 1;
		}

	

	GetDlgItemText(IDC_EDIT1,sText);							// Text aller Formeln holen

	sText.Replace('\n',';');
	sText.Replace('\r',' ');
	sText.Replace('\t',' ');
	pText			= sText;
	uLastErr		=  m_uEquErrors;
	sTextTxt		=  m_sEquErrText;
	m_uEquCount		=  0;
	m_uEquErrors	=  0;

	memset(m_aVarType,0,sizeof(m_aVarType));					// Variabeltypen initialieren




	for(;;)														// Einzelne Formeln aus den Textfeld holen
		{
			pText += strwlen(pText,0xE0);
		if(*pText== 0 )break;
		if(*pText==';')
			{
			pText++;
			continue;
			}

		if(pText[0]=='/')										// Ist die Formel auskommentiert mit "//..."
		if(pText[1]=='/')
			{
			pText += strlchar(pText,';');
			continue;
			}

		if(m_uEquCount>=MAX_EQU)
			{
			m_uEquErrors = 1;									// Zuviele Formeln
			break;
			}

		
		pText += strwlen (pText,0x00E0);
		pBase  = pText;
		iLen   = strcwlen(pText,0x2040);
		pLast  = pText;
		iLen   = strwlen(pText,0x1F);
		strlcpy(cVarName,pText,sizeof(cVarName),iLen);

		pText += iLen;
		pText += strwlen(pText,0xE0);

		if(!cVarName[0])										// Leerer Variabelname
			{
			m_sEquErrText.Format(_T("...%.20s..."),pLast);
			m_uEquErrors  = 4;									
			break;
			}

		if(!strwchar(cVarName[0],0x0E))							// Ungltiger Variabelname
			{
			m_sEquErrText = cVarName;
			m_uEquErrors  = 2;									
			break;
			}

		iLen = strbits(cVarName,aAbcBits);

		if(cVarName[iLen])										// Ungltiger Variabelname
			{
			m_sEquErrText = cVarName;
			m_uEquErrors  = 2;
			break;
			}

		if(*pText!='=')											// Keine Formel
			{
			m_sEquErrText.Format(_T("...%.20s..."),pLast);
			m_uEquErrors  = 3;
			break;
			}

		pText += 1;
		pText += strwlen(pText,0xE0);

		if(*pText==';' || *pText==0)							// Keine Formel
			{
			m_uEquErrors  = 3;
			break;
			}

		iLen   = strchar(pText,';');
		m_aEquFull   [m_uEquCount].Format(_T("%.*s"),iLen+pText-pBase,pBase);
		m_aEquations [m_uEquCount].Format(_T("%.*s"),iLen,pText);
		m_aEquFull   [m_uEquCount].TrimRight();
		m_aEquations [m_uEquCount].TrimRight();
		m_aEquResult [m_uEquCount] = cVarName;

		pText += iLen;

		for(uPos=0;uPos<m_uEquCount;uPos++)						// Suche doppelte Formeln
			{
			if(m_aEquResult[m_uEquCount]!=m_aEquResult[uPos])continue;
			m_sEquErrText = m_aEquResult[uPos];
			m_uEquErrors  = 11;
			break;
			}
		
		for(iRow=MAX_VAR-1;iRow>=0;iRow--)						// Suche Variabelnamen
			{
			if(m_aEquResult[m_uEquCount]==m_aVarName[iRow])break;
			}

		if(iRow<0 && m_uVarCount<MAX_VAR)						// Wurde die Variable nicht gefunden
			{
			m_aVarName[m_uVarCount] = m_aEquResult[m_uEquCount];
			iRow		 = m_uVarCount;
			m_uVarCount += 1;
			}

		if(bit_read(&m_uVarCombo,iRow))							// Ist die Variable von einer ComBobox gewhlt
			{
			for(uPos=0;uPos<MAX_COMBO;uPos++)
				{
				if(m_aComboRow[uPos]!=iRow)continue;
				break;
				}

			if(uPos>=3)continue;
			}

		m_aEquResVar [m_uEquCount] = iRow;
		m_aVarEqation[iRow] = m_uEquCount;
		bit_set(&m_uVarResult,iRow);

		m_uEquCount++;
		}


	if(m_uEquCount==0 && !m_uEquErrors)							// Keine Formel gefunden
		{
		m_uEquErrors = 5;
		}

	if(m_uEquErrors)											// Gibt es Fehler
		{
		m_uEquCount  = 0;
		goto Error;
		}


	UpdateList();												// Sortierte Liste mit den Variablen



//******************** Variablen und Formeln holen ****************************



	if(!m_bIs2D)												// 3D-Berechnung
		{
		iVar	= 2;
		iEnd	= 3;
		iIdx	= 2;
		}
	else if(m_uOptions2D&CDR_3LINES)							// 2D-Berechnung mit drei Variablen
		{
		m_aVarType [0] = TYPE_INPUT;
		m_aVarMark [0] = 1;

		bit_set(&m_uVarInput,0);
		bit_set(&m_uVarFixed,0);

		iVar	= 0;
		iEnd	= 3;
		iIdx	= 2;
		}
	else{														// 2D-Berechnung mit zwei Variablen
		iVar	= 1;
		iEnd	= 3;
		iIdx	= 2;
		}


	for(iNum=iVar;iNum<iEnd;iNum++)								// Suche Formeln fr die ausgewhlten Anzeigevariablen
		{
		   iRow   =  m_aComboRow [iNum];
		if(iRow<0 || m_aVarIntern[iRow]==0)
			{
			continue;
			}

		if(bit_read(&m_uVarOutput,iRow))
			{
			m_sEquErrText = m_aVarName[iRow];
			m_uEquErrors  = 13;
			m_uEquCount   = 0;
			goto Error;
			}

		bit_set(&m_uVarOutput,iRow);


		for(uPos=0;uPos<m_uEquCount;uPos++)						// Gibt es eine Formel fr die Anzeigevariablen
			{
			if(m_aEquResVar[uPos]==iRow)break;
			}

		if(uPos>=m_uEquCount)									// Variable kann nicht berechnet werden
			{
			m_sEquErrText.Format(_T("Es gibt keine Formel fr '%s' !"),(LPCTSTR)m_aVarName[iRow]);
			m_sEquErrText = m_aVarName[iRow];
			m_uEquErrors  = 6;
			m_uEquCount   = 0;
			goto Error;
			}
		
		m_aVarMark[iRow] = iIdx;
		iIdx++;
		}
	

	for(iNum=0;iNum<iVar;iNum++)								// Suche Formeln fr die ausgewhlten Laufvariablen
		{
		   iRow    =  m_aComboRow[iNum];
		if(iRow<0 || m_aVarIntern[iRow]==0)
			{
			continue;
			}

		if(bit_read(&m_uVarInput,iRow))
			{
			m_sEquErrText = m_aVarName[iRow];
			m_uEquErrors  = 14;
			m_uEquCount   = 0;
			goto Error;
			}

		if(bit_read(&m_uVarInput,iRow))
			{
			m_sEquErrText = m_aVarName[iRow];
			m_uEquErrors  = 15;
			m_uEquCount   = 0;
			goto Error;
			}

		bit_set(&m_uVarInput,iRow);
		bit_set(&m_uVarFixed,iRow);


		for(uPos=0;uPos<m_uEquCount;uPos++)						// Gibt es eine Formel fr die Laufvariablen
			{
			if(m_aEquResVar[uPos]==iRow)break;
			}

		if(uPos<m_uEquCount)									// Variable kann nicht berechnet werden
			{
			m_sEquErrText = m_aVarName[iRow];
			m_uEquErrors  = 12;
			m_uEquCount   = 0;
			goto Error;
			}
		
		m_aVarType[iRow] = TYPE_INPUT;
		m_aVarMark[iRow] = 1;
		}


	m_uVarMask = ((BitSet)1<<m_uVarCount)-1;


	for(uPos=0;uPos<m_uEquCount;uPos++)							// Formeln dekodieren
		{
		CalcInit(m_aEquGens+uPos,m_uVarCount,TokenCallback,this);

		iOk = CalcGenerate(m_aEquGens+uPos,m_aEquations[uPos],&pText);

		if(m_uEquErrors)goto Error;
		if(!iOk)
			{
			m_sEquErrText.Format(_T("%.20s"),pText);
			m_uEquErrors = 7;
			m_uEquCount  = 0;
			goto Error;
			}

		CalcDependency(m_aEquGens+uPos,m_aEquDepend+uPos,sizeof(m_aEquDepend[uPos])*8);
		m_aEquDepend[uPos] &= m_uVarMask;

		if((m_aEquDepend[uPos]>>m_aEquResVar[uPos])&1)			// Rekursive Formel
			{
			m_sEquErrText.Format(_T("'%.20s' wegen '%s'"),(LPCTSTR)m_aEquations[uPos],(LPCTSTR)m_aEquResult[uPos]);
			m_uEquErrors = 8;
			m_uEquCount  = 0;
			goto Error;
			}
		}


	m_uVarFixed &= ~m_uVarInput;
	m_uVarCombo &= ~m_uVarInput;


//******************** Rechenwege bestimmen ***********************************
BYTE			aMyLock[MAX_EQU];
BYTE			aMyEqu [MAX_EQU];
BitSet			uCalced;
BitSet			uBits;
BitSet			uNeed;
BitSet			uList;
BitSet			uDone;
BitSet			uLock;
BitSet			uPost;
BitSet			uOnly;
UINT			uNum;
UINT			uVar;
UINT			uLevel;
INT				iEqu;



	memset(m_aVarColor,0,sizeof(m_aVarColor));

	m_uEquListCnt	= 0;

	uPost	= 0;
	uCalced = 0;


	uOnly	= m_uVarList&~m_uVarResult&~m_uVarInput;			// Variable in der Liste ohne Formeln

	
	for(uNum=0,iEqu=m_uEquCount;iEqu>0;)						// Suche konstante Formeln
		{
		iEqu   -= 1;
		uPos	=  m_aEquResVar[iEqu];
		uBits	=  m_aEquDepend[iEqu];

		uBits  &= ~m_uVarFixed;
		uBits  &= ~m_uVarConst;
		uBits  &= ~uOnly;

		if(uBits || bit_read(&m_uVarConst,uPos))				// Hat die Formel keine Abhnigkeiten oder ist alles vorgegben
			{
			continue;
			}

		m_aEquConst[uNum] = iEqu;
		uNum++;

		bit_set(&m_uVarConst,uPos);								
		iEqu = m_uEquCount;
		}


	m_aEquConst[uNum]	= 0xFF;									
	m_aEquPost [0]		= 0xFF;


	uDone	    = m_uVarInput;
	uDone	   |= m_uVarFixed;									// Bereits definierte Variablen
	uDone	   |= m_uVarConst;
	uDone	   |= uOnly;

	uNeed		= m_uVarOutput;									// Welche Variablen mssen berechnet werden
	uNeed	   &=~uDone;

	uList		= uNeed&m_uVarResult;
	uVar		= bit_find_1(&uList,m_uVarCount);

	while(uVar<m_uVarCount)										// Alle zu berechnenden Variablen durchlaufen
		{
		   iEqu = m_aVarEqation[uVar];
		if(iEqu<0)
			{
			bit_clear(&uList,uVar);
			continue;
			}

		uLevel	= 0;
		uLock	= 0;

		for(;;)													// Alle Rechenwege prfen
			{
			uBits	=  m_aEquDepend[iEqu];
			uBits  &=  m_uVarResult;
			uBits  &= ~uDone;
			uBits  &= ~uLock;
			uPos	=  bit_find_1(&uBits,MAX_BIT);

			if(uPos>=m_uVarCount)								// Knnen Variablen fr diese Formel nicht berechnet werden
				{
				uBits  =  m_aEquDepend[iEqu];
				uBits &= ~uDone;

				if(uBits)										// Sind alle Variablen der Formel vorhanden
					{
					m_sEquErrText = m_aVarName[uPos];
					m_uEquErrors  = 16;
					uVar = MAX_BIT;
					break;
					}

				uPos = m_aEquResVar[iEqu];

				bit_clear(&uList  ,uPos);						// Die Formel konnte gelsst werden
				bit_set  (&uLock  ,uPos);
				bit_set  (&uDone  ,uPos);
				bit_set  (&uCalced,uPos);

				m_aEquList[m_uEquListCnt] = iEqu;
				m_uEquListCnt++;

				if(uLevel==0)break;

				uLevel--;
				iEqu	= aMyEqu [uLevel];
				uLock	= aMyLock[uLevel];

				continue;
				}

			aMyEqu [uLevel]	= iEqu;								// Eine Ebene hher zur nchsten Formel
			aMyLock[uLevel]	= uLock;

			bit_set(&uLock,uPos);

			uPos = bit_find_1(&uBits,m_uVarCount);
			iNum = m_aVarEqation[uPos];	

			if(iEqu<0 || uPos>m_uVarCount)
				{
				continue;
				}

			iEqu	= iNum;
			uLevel += 1;
			}

		uVar = bit_find_1(&uList,m_uVarCount,uVar);
		}


	if(m_uEquListCnt==0 || uList)								// Konnten einige Werte nicht berechnet werden
		{
		iNum		  = bit_find_1(&uList,MAX_BIT);
		m_sEquErrText =	(iNum<MAX_VAR)? m_aVarName[iNum]:_T("\?\?\?");
		m_uEquErrors  = 10;
		m_uEquListCnt = 0;
		goto Error;
		}

	m_aEquList[m_uEquListCnt] = 0xFF;

	uDone	= m_uVarInput;
	uDone  |= m_uVarFixed;
	uDone  |= m_uVarConst;
	uDone  |= uCalced;

	for(uNum=0,iEqu=m_uEquCount;iEqu>0;)						// Suche Formeln die am Ende berechnet werden
		{
		iEqu   -=  1;
		uPos	=  m_aEquResVar[iEqu];
		uBits	=  m_aEquDepend[iEqu];
		uBits  &= ~uDone;
		uDone  &= ~uOnly;

		if(uBits || bit_read(&uPost,uPos) || bit_read(&uDone,uPos))
			{
			continue;
			}

		m_aEquPost[uNum] = iEqu;
		uNum++;

		bit_set(&uPost,uPos);
		bit_set(&uDone,uPos);
		iEqu = m_uEquCount;
		}

	m_aEquPost[uNum] = 0xFF;


	for(uPos=0;uPos<m_uVarCount;uPos++)							// Variabeltypen setzen
		{
		if(bit_read(&uCalced,uPos))
			{
			m_aVarType[uPos] = TYPE_CALCED;						// Variable ist abhngit von X
			continue;
			}

		if(bit_read(&uPost,uPos))
			{
			m_aVarType[uPos] = TYPE_POST;						// Wird am Ende berechnet
			continue;
			}

		if(bit_read(&m_uVarConst,uPos))
			{
			m_aVarType[uPos] = TYPE_EQUCONST;					// Formelkonstande
			continue;
			}

		if(bit_read(&m_uVarFixed,uPos))
			{
			m_aVarType[uPos] = TYPE_EQUCONST;					// Fixierte Listenkkonstante
			continue;
			}

		if(bit_read(&m_uVarInput,uPos))
			{
			m_aVarType[uPos] = TYPE_INPUT;						// Verlaufskonstande (X)
			continue;
			}

		if(bit_read(&m_uVarList,uPos))
			{												
			m_aVarType[uPos] = TYPE_LIST;						// Listenkkonstante
			continue;
			}
		}


	if(m_bIs2D)													// Farben fr Marker
		{
		for(iRow=0,iNum=0;iRow<MAX_VAR;iRow++)
			{
			if(iRow>=(int)m_uVarListCnt)break;

				iNum = m_aVarMark[iRow];
			if(!iNum)continue;
			
			m_aVarColor[iRow] = CurveColor(-iNum);

			iNum++;
			}
		}

	if(uLastErr!=m_uEquErrors && m_pEquWnd)
		{
		m_pEquWnd->RedrawWindow();
		}



	return 0;

//******************** Fehlerauswertung ***************************************
Error:

	m_uEquCount = 0;

	if(sTextTxt!=m_sEquErrText)
		{
		m_uErrorChg = 1;
		}

	if(uLastErr!=m_uEquErrors && m_pEquWnd)
		{
		m_pEquWnd->RedrawWindow();
		}


return m_uEquErrors;
}

//*****************************************************************************
//*
//*		OnRedraw
//*
//*****************************************************************************
//	Fenster neu zeichnen
void CMathViewerDlg::OnRedraw()
{

	m_cBitmapWnd.RedrawWindow();

	if(m_bMouseFlag)
		{
		m_bMouseFlag = 0;
		MouseCallback(WM_MOUSEMOVE,0,m_sMousePt);
		}

}

//*****************************************************************************
//*
//*		OnOptionChanged
//*
//*****************************************************************************
//	Im Optionen-Dialog wurde etwas gendert
void CMathViewerDlg::OnOptionChanged()
{


	if(m_bIs2D && ((m_uOptions2D^m_uOptionsOld)&CDR_3LINES))	// Wechsel 2 auf 3 Linien
		{
		m_uOptionsOld = m_uOptions2D;
		ChangeLines();
		OnClick();
		}

	if(!m_bDrawStart)
		{
		m_bDrawStart = 1;
		m_sDrawTicker.Unlock();
		}

}

//*****************************************************************************
//*
//*		OnValueChanged
//*
//*****************************************************************************
//	Eine Konstande wurde verndert
void CMathViewerDlg::OnValueChanged()
{

	UpdateValues();

	if(!m_bDrawStart)
		{
		m_bDrawStart = 1;
		m_sDrawTicker.Unlock();
		}

}


//*****************************************************************************
//*
//*		ChangeLines
//*
//*****************************************************************************
//	Wurde von 2 auf 3 Linien umgestellt
void CMathViewerDlg::ChangeLines()
{
COptionenDlg	sDlg;
int				iSel;
int				iPos;


	if(m_uOptions2D&CDR_3LINES)
		{
		iSel = m_aCombo[0]->GetCurSel();	m_aCombo[0]->GetLBText(iSel,m_sTempTextX  );
		iSel = m_aCombo[1]->GetCurSel();	m_aCombo[1]->GetLBText(iSel,m_aComboTxt[0]);
		iSel = m_aCombo[2]->GetCurSel();	m_aCombo[2]->GetLBText(iSel,m_aComboTxt[1]);

		m_aComboTxt[2] = m_sTempTextY3;

		for(iPos=0;iPos<3;iPos++)
			{
			   iSel = m_aCombo[iPos]->FindString(-1,m_aComboTxt[iPos]);
			if(iSel<0)iSel=0;
			m_aCombo[iPos]->SetCurSel(iSel);
			}
		}
	else{
		iSel = m_aCombo[2]->GetCurSel();	m_aCombo[2]->GetLBText(iSel,m_sTempTextY3 );
		iSel = m_aCombo[1]->GetCurSel();	m_aCombo[1]->GetLBText(iSel,m_aComboTxt[2]);
		iSel = m_aCombo[0]->GetCurSel();	m_aCombo[0]->GetLBText(iSel,m_aComboTxt[1]);

		m_aComboTxt[0] = m_sTempTextX;

		for(iPos=0;iPos<3;iPos++)
			{
			   iSel = m_aCombo[iPos]->FindString(-1,m_aComboTxt[iPos]);
			if(iSel<0)iSel=0;
			m_aCombo[iPos]->SetCurSel(iSel);
			}
		}

}


//*****************************************************************************
//*
//*		OnOptions
//*
//*****************************************************************************
//	Einstellen der Optionen
void CMathViewerDlg::OnOptions()
{
COptionenDlg	sDlg;
unsigned		uOld;


	uOld				=  m_uOptions2D;
	m_uOptionsOld		=  m_uOptions2D;
	sDlg.m_pOptions2D	= &m_uOptions2D;
	sDlg.m_pOptions3D	= &m_uOptions3D;
	sDlg.m_pParams3D	= &m_sParams3D;
	sDlg.m_bIsD2		=  m_bIs2D;

	if(sDlg.DoModal()!=IDOK)return;

	OnOptionChanged();

}

//*****************************************************************************
//*
//*		Draw2D
//*
//*****************************************************************************
void CMathViewerDlg::Draw2D(BitmapImage *pImage)
{
char			cNames[512];
char		    aModes [MAX_VAR];
double		    aValues[MAX_VAR];
double		    aMinMax[MAX_COMBO];
double		   *pValues1;
double		   *pValues2;
double		   *pValues3;
double			dValue;
int				aSel[4];
int				iMarker;
int				iCount;
int				iPos;
int				iEqu;
int				iRow;
int				iLen;
int				iOff;
int				iAdd;
int				iOk;




	m_uOptions2D &= ~(CDR_IS_LOG_X|CDR_IS_LOG_1|CDR_IS_LOG_2|CDR_HAS_Y2|CDR_HAS_Y1|CDR_HAS_Y2|CDR_HAS_Y3);

	iLen = 0;

	if(m_uOptions2D&CDR_3LINES)									// Bis zu drei Linien zeichnen
		{
		iLen += strlcpy(cNames+iLen,m_aVarName [0],sizeof(cNames));	cNames[iLen] = '|';	iLen++;
		iLen += strlcpy(cNames+iLen,m_aUnitName[0],sizeof(cNames));	cNames[iLen] = '|';	iLen++;

		aMinMax[0] = m_aVarMin[0];
		aMinMax[1] = m_aVarMax[0];

		aSel[0]	= 0;
		aSel[1]	= m_aComboRow[0];
		aSel[2]	= m_aComboRow[1];
		aSel[3]	= m_aComboRow[2];
		iAdd    = 2;
		}
	else{
		aSel[0]	= m_aComboRow[0];
		aSel[1]	= m_aComboRow[1];
		aSel[2]	= m_aComboRow[2];
		aSel[3]	= -1;
		iAdd    =  0;
		}

	for(iPos=0;iPos<3;iPos++)									// Skalendaten holen
		{
		iRow					= m_aComboRow[iPos];
		aMinMax[iPos*2+0+iAdd]	= m_aVarMin  [iRow];
		aMinMax[iPos*2+1+iAdd]	= m_aVarMax  [iRow];

		iLen += strlcpy(cNames+iLen,m_aVarName [iRow],sizeof(cNames));	cNames[iLen] = '|';	iLen++;
		iLen += strlcpy(cNames+iLen,m_aUnitName[iRow],sizeof(cNames));	cNames[iLen] = '|';	iLen++;
		}


	if(iAdd==0)
		{
		aMinMax[6]	= 0;
		aMinMax[7]	= 0;
		cNames [iLen] = '|';	iLen++;
		cNames [iLen] = '|';	iLen++;
		}

	cNames[iLen-1] = 0;


	if(aSel[0]>=0 && m_aVarScala[aSel[0]]!=0)m_uOptions2D|=CDR_IS_LOG_X;
	if(aSel[1]>=0 && m_aVarScala[aSel[1]]!=0)m_uOptions2D|=CDR_IS_LOG_1;
	if(aSel[2]>=0 && m_aVarScala[aSel[2]]!=0)m_uOptions2D|=CDR_IS_LOG_2;
	if(aSel[3]>=0 && m_aVarScala[aSel[3]]!=0)m_uOptions2D|=CDR_IS_LOG_3;
	if(aSel[1]>=0)m_uOptions2D|=CDR_HAS_Y1;
	if(aSel[2]>=0)m_uOptions2D|=CDR_HAS_Y2;
	if(aSel[3]>=0)m_uOptions2D|=CDR_HAS_Y3;

	if(!pImage)pImage = m_cBitmapWnd.GetImage();
	iCount = CurveInit(&m_sCurve,pImage,m_uOptions2D,aMinMax,cNames);


	if(m_iDrawResCnt<iCount*3)									// Speicher fr die Kurven vergrern
		{
		if(m_pDrawResults)delete m_pDrawResults;

		m_iDrawResCnt	= ((iCount+0x0FFF)&~0x0FFF)*3;
		m_pDrawResults	= new double[m_iDrawResCnt];
		}

	pValues1	= m_pDrawResults;
	pValues2	= m_pDrawResults+m_iDrawResCnt/3;
	pValues3	= m_pDrawResults+m_iDrawResCnt/3*2;


 	for(iRow=0;iRow<(int)m_uDrawVarCnt;iRow++)					// Variabelwerte holen
		{
		m_aDrawValues[iRow] = m_aVarValue[iRow];
		}


	if(m_uConstEquCnt)											// Konstante Formeln berechnen
		{
		iOk = 1;

		for(iPos=0;iPos<(int)m_uConstEquCnt;iPos++)				// Formeln abarbeiten
			{
			iEqu   = m_aConstEquList[iPos];
			iRow   = m_aEquResVar   [iEqu];

			CalcSetValues(m_aConstEqu+iEqu,m_aDrawValues,m_uDrawVarCnt);
			dValue = CalcExecute(m_aConstEqu+iPos,&iOk);
			
			if(iRow<0 || m_aVarSet[iRow])continue;
			
			if(m_aVarType[iRow]>=TYPE_EQUCONST)
				{
				m_aDrawValues[iRow] = dValue;
				}
			}
		}

	for(iOff=0;iOff<iCount;iOff++)								// X-Werte durchlaufen
		{
		iOk		= 1;
		dValue	= CurvePosToVal(&m_sCurve,iOff,4);
		
		m_aDrawValues[m_aInpIndex[0]] = dValue;

		for(iPos=0;iPos<(int)m_uDrawEquCnt;iPos++)				// Formeln abarbeiten
			{
			iEqu   = m_aDrawEquList[iPos];
			iRow   = m_aEquResVar  [iEqu];

			CalcSetValues(m_aDrawEqu+iPos,m_aDrawValues,m_uDrawVarCnt);
			dValue = CalcExecute(m_aDrawEqu+iPos,&iOk);
			
			m_aDrawValues[iRow] = dValue;
			}

		pValues1[iOff] = m_aDrawValues[m_aOutIndex[0]];
		pValues2[iOff] = m_aDrawValues[m_aOutIndex[1]];
		pValues3[iOff] = m_aDrawValues[m_aOutIndex[2]];
		}


	for(iPos=0,iMarker=0;iPos<MAX_VAR;iPos++)					// Suche Marker
		{
		if(iPos>=(int)m_uVarListCnt)break;
		if(m_aVarMark[iPos]==0)continue;

		aValues[iMarker]	= m_aVarValue[iPos];
		aModes [iMarker]	= m_aVarMark [iPos]-1;

		iMarker++;
		}

	CurveDraw(&m_sCurve,pImage,pValues1,pValues2,pValues3,iMarker,aValues,aModes);

	m_bPanelValid = TRUE;

	PostMessage(WM_COMMAND,ID_REDRAW);

}

//*****************************************************************************
//*
//*		Draw3D
//*
//*****************************************************************************
void CMathViewerDlg::Draw3D(BitmapImage *pImage)
{
char			cNames[512];
double		    aMinMax[6];
int				aSel[4];
double			dValue;
double			dPosX;
double			dPosY;
int				iPosX;
int				iPosY;
int				iCnt;
int				iMax;
int				iPos;
int				iRow;
int				iEqu;
int				iLen;
int				iOk;



	m_uOptions3D &= ~(PDR_IS_LOG_X|PDR_IS_LOG_Y|PDR_IS_LOG_Z);

	aSel[0]	= m_aComboRow[0];
	aSel[1]	= m_aComboRow[1];
	aSel[2]	= m_aComboRow[2];

	if(aSel[0]>=0 && m_aVarScala[aSel[0]]!=0)m_uOptions2D|=PDR_IS_LOG_X;
	if(aSel[1]>=0 && m_aVarScala[aSel[1]]!=0)m_uOptions2D|=PDR_IS_LOG_Y;
	if(aSel[2]>=0 && m_aVarScala[aSel[2]]!=0)m_uOptions2D|=PDR_IS_LOG_Z;



	for(iPos=0,iLen=0;iPos<3;iPos++)							// Skalendaten holen
		{
		iRow				= m_aComboRow[iPos];
		aMinMax[iPos*2+0]	= m_aVarMin  [iRow];
		aMinMax[iPos*2+1]	= m_aVarMax  [iRow];

		iLen += strlcpy(cNames+iLen,m_aVarName [iRow],sizeof(cNames));	cNames[iLen] = '|';	iLen++;
		iLen += strlcpy(cNames+iLen,m_aUnitName[iRow],sizeof(cNames));	cNames[iLen] = '|';	iLen++;
		}

	cNames[iLen] = 0;


	if(!pImage)pImage = m_cBitmapWnd.GetImage();
	iCnt   = PlaneInit(&m_sPlane,pImage,m_uOptions3D,aMinMax,cNames,&m_sParams3D);

	if(m_iDrawResCnt<iCnt*iCnt)									// Speicher vergrern
		{
		if(m_pDrawResults)delete m_pDrawResults;
		iMax			= (iCnt+0xFF)&~0xFF;
		m_iDrawResCnt	= iMax*iMax;
		m_pDrawResults	= new double[m_iDrawResCnt];
		}


	for(iPos=0;iPos<(int)m_uVarCount;iPos++)					// Variabelwerte holen
		{
		m_aDrawValues[iPos] = m_aVarValue[iRow];
		}


	#if  LOG_DRAW
	for(iEqu=0;iEqu<(int)m_uEquCount;iEqu++)					// Formeln ausgeben
		{
		CalcSetValues(m_aEquGens+iEqu,m_aDrawValues,m_uDrawVarCnt);
		CalcPrint(m_aEquGens+iEqu);
		}

	printf("-------------------\n");

	for(iEqu=0;iEqu<(int)m_uDrawEquCnt;iEqu++)
		{
		CalcSetValues(m_aDrawEqu+iEqu,m_aDrawValues,m_uDrawVarCnt);
		CalcPrint(m_aDrawEqu+iEqu);
		}
	#endif

	if(m_uConstEquCnt)											// Konstante Formeln berechnen
		{
		iOk = 1;

		for(iPos=0;iPos<(int)m_uConstEquCnt;iPos++)				// Formeln abarbeiten
			{
			iEqu   = m_aConstEquList[iPos];
			iRow   = m_aEquResVar   [iEqu];

			CalcSetValues(m_aConstEqu+iEqu,m_aDrawValues,m_uDrawVarCnt);
			dValue = CalcExecute(m_aConstEqu+iPos,&iOk);
			
			if(iRow<0 || m_aVarSet[iRow])continue;
			
			if(m_aVarType[iRow]>=TYPE_EQUCONST)
				{
				m_aDrawValues[iRow] = dValue;
				}
			}
		}

	for(iPosY=0;iPosY<iCnt;iPosY++)								// Werte berechnen
	for(iPosX=0;iPosX<iCnt;iPosX++)
		{
		dPosX	= PlaneStepToVal(&m_sPlane,iPosX,0);
		dPosY	= PlaneStepToVal(&m_sPlane,iPosY,1);

		iOk							  = 1;
		m_aDrawValues[m_aInpIndex[0]] = dPosX;
		m_aDrawValues[m_aInpIndex[1]] = dPosY;

		for(iPos=0;iPos<(int)m_uDrawEquCnt;iPos++)				// Formeln abarbeiten
			{
			iEqu   = m_aDrawEquList[iPos];
			iRow   = m_aEquResVar  [iEqu];

			CalcSetValues(m_aDrawEqu+iPos,m_aDrawValues,m_uDrawVarCnt);
			dValue = CalcExecute(m_aDrawEqu+iPos,&iOk);
			
			m_aDrawValues[iRow] = dValue;
			}

		m_pDrawResults[iPosX+iPosY*iCnt] = m_aDrawValues[m_aOutIndex[0]];
		}

	PlaneDraw(&m_sPlane,pImage,m_pDrawResults);

	m_bPanelValid = TRUE;

	PostMessage(WM_COMMAND,ID_REDRAW);

}

//*****************************************************************************
//*
//*		UpdateCalculator
//*
//*****************************************************************************
//	Inizialisiert die Formeln fr das Zeichen
//	Ergibt 1 wenn ok bzw. 0 bei einem Fehler
int	CMathViewerDlg::UpdateCalculator()
{
BYTE		aConst[MAX_VAR];
int			iPos;
int			iEqu;
int			iRow;
int			iEnd;
int			iIdx;


	if(m_bDrawLock)												// Wird gerade gezeichnet
		{
		m_bDrawReinit = 1;
		return 1;
		}


	m_sDrawUpdate.Lock();

	m_bDrawReinit	= 0;


 	m_uOptions2D &= ~(CDR_IS_LOG_X|CDR_IS_LOG_1|CDR_IS_LOG_2|CDR_HAS_Y2);

	if(m_aVarScala[0]!=0)m_uOptions2D|=CDR_IS_LOG_X;
	if(m_aVarScala[1]!=0)m_uOptions2D|=CDR_IS_LOG_1;
	if(m_aVarScala[2]!=0)m_uOptions2D|=CDR_IS_LOG_2;
	if(m_aComboRow[2]>=0)m_uOptions2D|=CDR_HAS_Y2;


	m_uOptions3D&=~(PDR_IS_LOG_X|PDR_IS_LOG_Y|PDR_IS_LOG_Z);

	if(m_aVarScala[0]!=0)m_uOptions3D|=PDR_IS_LOG_X;
	if(m_aVarScala[1]!=0)m_uOptions3D|=PDR_IS_LOG_Y;
	if(m_aVarScala[2]!=0)m_uOptions3D|=PDR_IS_LOG_Z;


	if(m_uError || m_uEquListCnt==0)							// Gibt es Fehler
		{
		m_bDraw2D	  = 0;
		m_uDrawEquCnt = 0;
		m_uDrawVarCnt = 0;
		m_sDrawUpdate.Unlock();
		return 0;
		}

	m_uDrawVarCnt = m_uVarCount;

	memset(m_aOutIndex,0,sizeof(m_aOutIndex));
	memset(m_aInpIndex,0,sizeof(m_aInpIndex));
	memset(aConst	  ,0,sizeof(aConst     ));


	if(!m_bIs2D)												// 3D-Modus
		{
		iPos = 2;
		iEnd = 3;

		   iRow = m_aComboRow[0];
		if(iRow<0 || iRow>=MAX_VAR)iRow=0;
		m_aInpIndex[0] = iRow;									// X-Variable

		   iRow = m_aComboRow[1];
		if(iRow<0 || iRow>=MAX_VAR)iRow=0;						// Y-Variable
		m_aInpIndex[0] = iRow;
		}
	else if(m_uOptions2D&CDR_3LINES)							// 2D-Modus mit 3 Zeilen
		{
		iPos = 0;
		iEnd = 3;

		m_aInpIndex[0] = 0;										// X-Variable
		}
	else{														// 2D-Modus mit 2 Zeilen
		iPos = 0;
		iEnd = 3;

		   iRow = m_aComboRow[0];
		if(iRow<0 || iRow>=MAX_VAR)iRow=0;
		m_aInpIndex[0] = iRow;									// X-Variable
		}


	for(iIdx=0;iPos<iEnd;iPos++,iIdx++)							// Positionen der Ergebinsvariablen 
		{	
		   iRow = m_aComboRow[iPos];
		if(iRow<0 || iRow>=MAX_VAR)iRow=0;
		
		m_aOutIndex[iIdx] = iRow;
		}


	
 	for(iRow=0;iRow<(int)m_uVarCount;iRow++)					// Variablelwerte holen
		{
		m_aDrawValues[iRow] = m_aVarValue[iRow];
		}

 	for(iPos=0;iPos<MAX_EQU;iPos++)								// Berechnete Variablen als nicht konstand markieren
		{
		   iEqu = m_aEquList[iPos];
		if(iEqu==0xFF)break;

		   iRow = m_aDrawEquVar[iEqu];
		if(iRow>=0)
			{
			aConst[iRow] = 0;
			}
		}

 	for(iPos=0;iPos<MAX_EQU;iPos++)								// Formeln kopieren die die Kurven berechnen
		{
		   iEqu = m_aEquList[iPos];
		if(iEqu==0xFF)break;

		CalcCopy	 (m_aEquGens+iEqu,m_aDrawEqu+iPos);
		CalcSetValues(m_aDrawEqu+iPos,m_aDrawValues,m_uDrawVarCnt);
		CalcCompress (m_aDrawEqu+iPos,aConst       ,m_uDrawVarCnt);
		}


	memcpy(m_aDrawEquList,m_aEquList,iPos+1);
	m_uDrawEquCnt	= iPos;

 	for(iPos=0;iPos<MAX_EQU;iPos++)								// Formeln kopieren die am ENde berechnet werden
		{
		   iEqu = m_aEquPost[iPos];
		if(iEqu==0xFF)break;

		CalcCopy	 (m_aEquGens+iEqu,m_aPostEqu+iPos);
		CalcSetValues(m_aPostEqu+iPos,m_aDrawValues,m_uDrawVarCnt);
		}

	memcpy(m_aPostEquList,m_aEquPost,iPos+1);
	m_uPostEquCnt	= iPos;

 	for(iPos=0;iPos<MAX_EQU;iPos++)								// Formeln kopieren die konstant sind
		{
		   iEqu = m_aEquConst[iPos];
		if(iEqu==0xFF)break;

		CalcCopy	 (m_aEquGens +iEqu,m_aConstEqu+iPos);
		CalcSetValues(m_aConstEqu+iPos,m_aDrawValues,m_uDrawVarCnt);
		}

	memcpy(m_aConstEquList,m_aEquConst,iPos+1);
	m_uConstEquCnt	= iPos;
	

	m_bDraw2D		= m_bIs2D;
	m_bDrawStart	= 1;
	m_sDrawUpdate.Unlock();
	m_sDrawTicker.Unlock();



return 1;
}

//*****************************************************************************
//*
//*		DrawProc
//*
//*****************************************************************************
UINT CMathViewerDlg::DrawProc(LPVOID pParam){return ((CMathViewerDlg*)pParam)->DrawProc();}
UINT CMathViewerDlg::DrawProc()
{

	m_bDrawRunning = TRUE;

	while(!m_bDrawStop)
		{
		m_sDrawTicker.Lock(1000);								// Warte auf Neustart

		if(!m_bDrawStart )continue;								// Nichts neu zu zeichnen
		if(!m_uDrawEquCnt)continue;

		m_bDrawStart = 0;
		m_bDrawLock  = 1;
		Sleep(20);

		m_sDrawUpdate.Lock();
		m_cBitmapWnd .Lock();
		m_sDrawLocker.Lock();

		if(m_bDraw2D)											// 2D oder 3D zeichnen
				Draw2D();
		else	Draw3D();

		m_sDrawLocker.Unlock();
		m_cBitmapWnd .Unlock();
		m_sDrawUpdate.Unlock();

		m_bDrawLock = 0;

		Sleep(50);
		}

	m_bDrawRunning = FALSE;


return 0;
}

//*****************************************************************************
//*
//*		OnPicture
//*
//*****************************************************************************
void CMathViewerDlg::OnPicture()
{
CPictureDlg		sDlg;
BitmapImage		sImg;
int				iRet;


	if(!m_uDrawEquCnt || m_uEquErrors || m_uError)			// Nichts neu zu zeichnen
		{
		MessageBox("Es ist keine gltige Formel vorhanden.","Fehler",MB_OK|MB_ICONERROR);
		return;
		}


	if(sDlg.DoModal()!=IDOK)return;


	sImg.SetSize(32,sDlg.m_uSizeX,sDlg.m_uSizeY);


	m_sDrawUpdate.Lock();
	m_sDrawLocker.Lock();

	if(m_bDraw2D)
			Draw2D(&sImg);
	else	Draw3D(&sImg);

	m_uEquUpdate = 1;

	m_sDrawLocker.Unlock();
	m_sDrawUpdate.Unlock();



	if(sDlg.m_bClipBoard)
		{
		sImg.Copy();
		return;
		}

	if(ExistFile(sDlg.m_sPath))
		{
		if(MessageBox("Die Date existiert bereits !\nSoll sie berschrieben werden ?","Frage",MB_OKCANCEL|MB_ICONQUESTION)!=IDOK)return;
		}

	iRet = ImageSaver(sDlg.m_sPath,&sImg);

	switch(iRet)
		{
	case  0:	MessageBox("Das Bild wurde gespeichert.","Info"  ,MB_OK|MB_ICONINFORMATION);break;
	case -1:	MessageBox("Fehler beim Bildspeichern !","Fehler",MB_OK|MB_ICONERROR);		break;
	case -2:	MessageBox("Unbekanntes Dateiformat !"	,"Fehler",MB_OK|MB_ICONERROR);		break;
	case -3:	MessageBox("Kann Datei nicht ffnen !"	,"Fehler",MB_OK|MB_ICONERROR);		break;
	default:	MessageBox("Unbekannter Fehler !"		,"Fehler",MB_OK|MB_ICONERROR);		break;
		}


}


//*****************************************************************************
//*
//*		DoStore
//*
//*****************************************************************************
int CMathViewerDlg::DoStore()
{
CPictureDlg		sDlg;
BitmapImage		sImg;
int				iRet;


	if(!m_uDrawEquCnt || m_uEquErrors || m_uError)			// Nichts neu zu zeichnen
		{
		printf("\nEs ist keine gueltige Formel vorhanden.\n");
		return -5;
		}

	if(m_uStoreX>4096)m_uStoreX=4096;
	if(m_uStoreY>4096)m_uStoreY=4096;

	sImg.SetSize(32,m_uStoreX,m_uStoreY);


	m_sDrawUpdate.Lock();
	m_sDrawLocker.Lock();

	if(m_bDraw2D)
			Draw2D(&sImg);
	else	Draw3D(&sImg);

	m_uEquUpdate = 1;

	m_sDrawLocker.Unlock();
	m_sDrawUpdate.Unlock();

	if(!stricmp(m_sStorePath,"CLIPBOARD"))
		{
		sImg.Copy();
		return 0;
		}

	iRet = ImageSaver(m_sStorePath,&sImg);

	switch(iRet)
		{
	case  0:	printf("\nDas Bild wurde gespeichert.\n");break;
	case -1:	printf("\nFehler beim Bildspeichern !\n");break;
	case -2:	printf("\nUnbekanntes Dateiformat !\n"	);break;
	case -3:	printf("\nKann Datei nicht oeffnen !\n"	);break;
	default:	printf("\nUnbekannter Fehler !\n"		);break;
		}


return iRet;
}

//*****************************************************************************
//*
//*		DrawCallback
//*
//*****************************************************************************
void CMathViewerDlg::DrawCallback (void *pParam,CDC *pDc,PAINTSTRUCT *pPaint){((CMathViewerDlg*)pParam)->DrawCallback (pDc,pPaint);}
void CMathViewerDlg::DrawCallback (             CDC *pDc,PAINTSTRUCT *pPaint)
{
int		iPos;


	if(m_iXorOn && m_iXorMode==1 && m_bIs2D)
		{
		pDc->SelectObject(&m_sXorDash);
		pDc->SetROP2     (R2_XORPEN);

		iPos = (m_iXorOn==2)? 1:0;

		for(;iPos<2;iPos++)
			{
			pDc->MoveTo(m_aXorX[iPos*2+0],m_aXorY[iPos*2+0]);
			pDc->LineTo(m_aXorX[iPos*2+1],m_aXorY[iPos*2+1]);
			}
		}
	else if(m_iXorOn && m_iXorMode==2 && !m_bIs2D)
		{
		pDc->SelectObject(&m_sXorDash);
		pDc->SetROP2     (R2_XORPEN);

		for(iPos=0;iPos<4;iPos++)
			{
			pDc->MoveTo(m_aXorX[iPos*2+0],m_aXorY[iPos*2+0]);
			pDc->LineTo(m_aXorX[iPos*2+1],m_aXorY[iPos*2+1]);
			}
		}
	else{
		m_iXorOn = 0;
		}
}

//*****************************************************************************
//*
//*		MouseCallback
//*
//*****************************************************************************
void CMathViewerDlg::MouseCallback(void *pParam,UINT uType,UINT nFlags,CPoint sPoint){((CMathViewerDlg*)pParam)->MouseCallback(uType,nFlags,sPoint);}
void CMathViewerDlg::MouseCallback(             UINT uType,UINT nFlags,CPoint sPoint)
{
CDC		   *pDc;
BitSet		uIgnore;
BOOL		bOldMode;
double		aVals[MAX_VAR];
double		aLine[3];
double		dValX;
double		dVal1;
double		dVal2;
double		dVal3;
int			iPosX1;
int			iPosX2;
int			iPosY1;
int			iPosY2;
int			iPos;
int			iRow;
int			iOkX;
int			iOk1;
int			iOk2;
int			iOk3;
int			iOld;


	if(uType!=WM_MOUSEMOVE)return;

	if(!m_bPanelValid)										// Ist das Bild noch nicht bereit
		{
		m_sMousePt	 = sPoint;
		m_bMouseFlag = TRUE;
		return;
		}



	if(m_bIs2D)												// 2D Fadenkreuz
		{
		bOldMode	 = 	m_bMouseMode;
		m_bMouseMode = (GetAsyncKeyState(VK_CONTROL)&0x8000)? 1:0;

		iOld = m_iXorOn;
		pDc	 = m_cBitmapWnd.GetDC();
		if(!pDc)return;

		pDc->SelectObject(&m_sXorDash);
		pDc->SetROP2     (R2_XORPEN);

		if(m_iXorOn && m_iXorMode)
			{												// Alte Linien entfernen
			iPos = (m_iXorOn==2)? 1:0;

			for(;iPos<2;iPos++)
				{
				pDc->MoveTo(m_aXorX[iPos*2+0],m_aXorY[iPos*2+0]);
				pDc->LineTo(m_aXorX[iPos*2+1],m_aXorY[iPos*2+1]);
				}

			m_iXorOn = 0;
			}


		CurveFrame(&m_sCurve,iPosX1,iPosY1,iPosX2,iPosY2);

		if(sPoint.x>=iPosX1)
		if(sPoint.x<=iPosX2)
		if(sPoint.y>=iPosY1)
		if(sPoint.y<=iPosY2)
			{
			if(!m_iXorOn && !iOld)							// Wird das Fadenkreuz neu eingeblendet
				{
				m_iXorOn       = 1;

				for(iPos=0;iPos<MAX_VAR;iPos++)
					{
					if(iPos>(int)m_uVarListCnt)break;
					m_dXorValue[iPos] = GetValue(iPos,1,1);
					}
				}

			if(m_bMouseMode!=bOldMode)						// Werte wieder herstellen bei Modusnderung
				{
				for(iPos=0;iPos<MAX_VAR;iPos++)
					{
					if(iPos>=(int)m_uVarListCnt)break;
					SetValue(m_dXorValue[iPos],iPos,1,3);
					}
				}

			m_aXorX[0]	= iPosX1;
			m_aXorX[1]	= iPosX2;
			m_aXorY[0]	= sPoint.y;
			m_aXorY[1]	= sPoint.y;
			m_aXorX[2]	= sPoint.x;
			m_aXorX[3]	= sPoint.x;
			m_aXorY[2]	= iPosY1;
			m_aXorY[3]	= iPosY2;
			m_sXorPoint	= sPoint;
			m_iXorOn	= (m_bMouseMode)? 1:2;
			m_iXorMode	= 1;

			iPos = (m_iXorOn==2)? 1:0;

			for(;iPos<2;iPos++)								// Neues Fadenkreuz zeichnen
				{
				pDc->MoveTo(m_aXorX[iPos*2+0],m_aXorY[iPos*2+0]);
				pDc->LineTo(m_aXorX[iPos*2+1],m_aXorY[iPos*2+1]);
				}

			if(!m_bMouseMode)								// Nur X-Linie mit nachrechnen
				{
				dValX = CurvePosToVal(&m_sCurve,sPoint.x,0,&iOkX);

				if(iOkX)
					{
					iRow	= (m_uOptions2D&CDR_3LINES)? 0:m_aComboRow[0];
					uIgnore = 0;

					if(iRow>=0)
						{
						aVals[iRow] = dValX;
						bit_set(&uIgnore,iRow);
						}

					CalcValues(aVals,uIgnore);

					for(iRow=0;iRow<MAX_VAR;iRow++)
						{
						if(iRow>=(int)m_uVarListCnt)break;

						if(m_aVarType[iRow]<TYPE_POST && m_aVarType[iRow]!=TYPE_INPUT)
							{
							continue;
							}

						SetValue(aVals[iRow],iRow,1,7);
						}
					}
				}
			else if(m_uOptions2D&CDR_3LINES)
				{
				dValX = CurvePosToVal(&m_sCurve,sPoint.x,0,&iOkX);
				dVal1 = CurvePosToVal(&m_sCurve,sPoint.y,1,&iOk1);
				dVal2 = CurvePosToVal(&m_sCurve,sPoint.y,2,&iOk2);
				dVal3 = CurvePosToVal(&m_sCurve,sPoint.y,3,&iOk3);

				if(iOkX)SetValue(dValX,0             ,1,7);
				if(iOk1)SetValue(dVal1,m_aComboRow[0],1,7);
				if(iOk2)SetValue(dVal2,m_aComboRow[1],1,7);
				if(iOk3)SetValue(dVal3,m_aComboRow[2],1,7);
				}
			else{
				dValX = CurvePosToVal(&m_sCurve,sPoint.x,0,&iOkX);
				dVal1 = CurvePosToVal(&m_sCurve,sPoint.y,1,&iOk1);
				dVal2 = CurvePosToVal(&m_sCurve,sPoint.y,2,&iOk2);

				if(iOkX)SetValue(dValX,m_aComboRow[0],1,7);
				if(iOk1)SetValue(dVal1,m_aComboRow[1],1,7);
				if(iOk2)SetValue(dVal2,m_aComboRow[2],1,7);
				}
			}

		m_cBitmapWnd.ReleaseDC(pDc);

		if(iOld && !m_iXorOn)								// Alte X/Y/Z Werte wieder herstellen
			{
			for(iPos=0;iPos<MAX_VAR;iPos++)
				{
				if(iPos>=(int)m_uVarListCnt)break;
				SetValue(m_dXorValue[iPos],iPos,1,3);
				}
			}
		}
	else{													// 3D Fadenkreuz
		iOld = m_iXorOn;
		pDc	 = m_cBitmapWnd.GetDC();
		if(!pDc)return;

		pDc->SelectObject(&m_sXorDash);
		pDc->SetROP2     (R2_XORPEN);

		if(m_iXorOn && m_iXorMode==2)						// Alte Linien entfernen
			{
			for(iPos=0;iPos<4;iPos++)
				{
				pDc->MoveTo(m_aXorX[iPos*2+0],m_aXorY[iPos*2+0]);
				pDc->LineTo(m_aXorX[iPos*2+1],m_aXorY[iPos*2+1]);
				}

			m_iXorOn = 0;
			}

		if(PlaneCoorToVal(&m_sPlane,sPoint.x,sPoint.y,aVals))
			{
			if(!m_iXorOn && !iOld)							// Wird das Fadenkreuz neu eingeblendet
				{
				m_iXorOn       = 1;
				m_dXorValue[0] = GetValue(m_aComboRow[0],1,1);
				m_dXorValue[1] = GetValue(m_aComboRow[1],1,1);
				m_dXorValue[2] = GetValue(m_aComboRow[2],1,1);
				}

			aLine[0] = aVals[0];
			aLine[1] = m_aVarMin[m_aComboRow[1]];
			aLine[2] = m_aVarMin[m_aComboRow[2]];

			PlaneValToCoor(&m_sPlane,m_aXorX[0],m_aXorY[0],aLine);	aLine[2] = aVals[2];
			PlaneValToCoor(&m_sPlane,m_aXorX[1],m_aXorY[1],aLine);

			m_aXorX[4] = m_aXorX[1];
			m_aXorY[4] = m_aXorY[1];

			aLine[0] = m_aVarMin[m_aComboRow[0]];
			aLine[1] = aVals[1];
			aLine[2] = m_aVarMin[m_aComboRow[2]];

			PlaneValToCoor(&m_sPlane,m_aXorX[2],m_aXorY[2],aLine);	aLine[2] = aVals[2];
			PlaneValToCoor(&m_sPlane,m_aXorX[3],m_aXorY[3],aLine);

			m_aXorX[6] = m_aXorX[3];
			m_aXorY[6] = m_aXorY[3];

			aLine[0] = aVals[0];
			aLine[1] = aVals[1];
			aLine[2] = aVals[2];

			PlaneValToCoor(&m_sPlane,m_aXorX[5],m_aXorY[5],aLine);	aLine[2] = aVals[2];

			m_aXorX[7] = m_aXorX[5];
			m_aXorY[7] = m_aXorY[5];


			for(iPos=0;iPos<4;iPos++)						// 3D-Fadenkreuz zeichnen
				{
				pDc->MoveTo(m_aXorX[iPos*2+0],m_aXorY[iPos*2+0]);
				pDc->LineTo(m_aXorX[iPos*2+1],m_aXorY[iPos*2+1]);
				}

			m_iXorOn	= 1;
			m_iXorMode	= 2;
			m_sXorPoint	= sPoint;

			SetValue(aVals[0],m_aComboRow[0],1,7);
			SetValue(aVals[1],m_aComboRow[1],1,7);
			SetValue(aVals[2],m_aComboRow[2],1,7);
			}

		m_cBitmapWnd.ReleaseDC(pDc);

		if(iOld && !m_iXorOn)								// Alte X/Y/Z Werte wieder herstellen
			{
			SetValue(m_dXorValue[0],m_aComboRow[0],1,3);
			SetValue(m_dXorValue[1],m_aComboRow[1],1,3);
			SetValue(m_dXorValue[2],m_aComboRow[2],1,3);
			}
		}

}

//*****************************************************************************
//*
//*		OnHelp
//*
//*****************************************************************************
void CMathViewerDlg::OnHelp()
{
TCHAR			cBuffer[0xF000];
TCHAR			cPath[256];
CFileBuffer		sFile;
static int		iDone=0;
int				iLen;



	if(!iDone)
		{
		if(!sFile.Open("res://HTML/MathViewer.html"))
			{
			return;
			}

		iLen = sFile.Read(cBuffer,sizeof(cBuffer));

		GetExePath(cPath);
		strcat(cPath,"MathViewer.htm");
		SaveMemory(cPath,cBuffer,iLen);

		if(!sFile.Open("res://HTML/MathViewer.png"))
			{
			return;
			}

		iLen = sFile.Read(cBuffer,sizeof(cBuffer));

		GetExePath(cPath);
		strcat(cPath,"MathViewer.png");
		SaveMemory(cPath,cBuffer,iLen);
		iDone = 1;
		}


	GetExePath(cPath);
	strcat(cPath,"MathViewer.htm");
	ShellExecute(0,"open",cPath,0,0,SW_SHOWDEFAULT);



}

