//*****************************************************************************
//*
//*
//*		MathViewerDlg.h
//*
//*
//*****************************************************************************
#ifndef		AFX_MATHVIEWERDLG_H__32FA3FBA_EB9A_4744_89C6_F23FCB2F4DB8__INCLUDED_
#define		AFX_MATHVIEWERDLG_H__32FA3FBA_EB9A_4744_89C6_F23FCB2F4DB8__INCLUDED_

#if _MSC_VER > 1000
#pragma		once
#endif


#include	"CurveDrawer.h"
#include	"PlaneDrawer.h"
#include	"SemaphoreEx.h"
#include	"CalcGenerator.h"

#define 	MAX_COMBO		8
#define 	MAX_VAR			32
#define 	MAX_EQU			32
#define 	MAX_BIT			(sizeof(BitSet)*8)

#define 	TYPE_UNUSED		0									// Variable ist unbenutzt
#define 	TYPE_LIST		1									// Listenkkonstante 
#define 	TYPE_INPUT		2									// Verlaufskonstande (X)
#define 	TYPE_EQUCONST	3									// Formelkonstande 
#define 	TYPE_POST		4									// Wird am Ende berechnet
#define 	TYPE_CALCED		5									// Variable ist abhngit von X

typedef	unsigned	BitSet;

//*****************************************************************************
//*
//*		CMathViewerDlg
//*
//*****************************************************************************
class CMathViewerDlg : public CDialog
{
public:

	CMathViewerDlg(CWnd *pParent=NULL);							// Standard-Konstruktor
   ~CMathViewerDlg();

	BOOL			m_iStoreMode;								// 1=Formel laden 2=Nur ein Bild speichern
	CString			m_sStorePath;								// Pfad fr Bild
	CString			m_sStoreLoad;								// Pfad mit MVI-Datei
	unsigned		m_uStoreX;									// Bildgre fr's Speichern
	unsigned		m_uStoreY;									//			*

	//{{AFX_DATA(CMathViewerDlg)
	enum { IDD = IDD_MATHVIEWER_DIALOG };
	CString		m_sFormular;
	BOOL		m_bSel2D;
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CMathViewerDlg)
protected:
	virtual void DoDataExchange(CDataExchange *pDX);			// DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

protected:

	HICON			m_hIcon;									// Icon-Handle
	CRect			m_cRect;									// Fensterabmessungen beim Start (Window-Bereich)
	CBitmapWnd		m_cBitmapWnd;								// Bitmap-Fenster fr Grafik
	CTreeListCtrl	m_cListWnd;									// List-Fenster mit Variabeldaten
	CStringChain	m_sVarList;									// Sortierte Variabelliste 
	CStringChain	m_sVarClick;								// Ist die Nummer mit der eine Variable geklickt wurde
	CString			m_sError;									// Algemeine Fehlertext
	CurveData		m_sCurve;									// Daten fr 2D Kurfe
	PlaneData		m_sPlane;									// Daten fr 3D Flche
	BOOL			m_bLoadOption;								// Sollen die Optionen geladen werden
	UINT			m_uVarCount;								// Anzahl aller Varibalen (Liste+Text) 
	UINT			m_uVarListCnt;								// Anzahl aller Varibalen (nur Liste) 
	UINT			m_uClickNr;									// Aktuelle Klicknummer
	UINT			m_uErrorChg;								// Hat sich der Fehlertext verndert
	UINT			m_uError;									// Algemeine Fehlernummer fr Fehlertext
	UINT			m_uLastUsed;								// Welcher XYZ-Slider wurde zuletzt benutzt (0=X 1=Y 2=Z)
	CPoint			m_sMousePt;									// Mauskoordinaten fr Wiederholung
	BOOL			m_bMouseFlag;								// Mauskoordinaten nach Zeichnen nochmals senden
	BOOL			m_bMouseMode;								// Welche Maus Modus soll benutzt werden
	int				m_iSizeX;									// Aktuelle Fenstergre
	int				m_iSizeY;									//		*
	int				m_iStartX;									// Minimale Gre fr Fenster (Window-Bereich)
	int				m_iStartY;									//		*
	int				m_iMinX;									// Minimale Gre fr Fenster (Client-Bereich)
	int				m_iMinY;									//		*
	BOOL			m_bInit;									// Ist der Dialog initialisiert
	BOOL			m_bIs2D;									// Ist eine 2D Darstellung eingestellt
	CWnd	       *m_pEquWnd;									// Zeiger auf Textfeld mit Formeln
	static CBrush	m_sErrBrush;								// Brusch mit der Fehlerfarbe
	CPen			m_sXorDash;									// Ist der strichlierte Stift fr XOR-Objekte 2D
	BOOL			m_bPanelValid;								// Ist das Bild odnungs gem gezeichnet

	CRect			m_aSizeRect  [MAX_COMBO];					// Gre der Fenster beim Start
	BYTE			m_aSizeType  [MAX_COMBO];					// Bit0=X nderbar   Bit1=Y nderbar
	CWnd	       *m_aSizeWnd   [MAX_COMBO];					// Zeiger auf die Fenster deren Grer vernderbar ist
	CSliderCtrl	   *m_aSlider    [MAX_COMBO];					// Zeiger auf die Slider
	CComboBox	   *m_aCombo     [MAX_COMBO];					// Zeiger auf die ComboBox'en
	BOOL			m_aComboErr  [MAX_COMBO];					// Gibt es einen Fehler bei der ComboBox
	int 		    m_aComboRow  [MAX_COMBO];					// Welche Variabel ist ausgewhlt (-1=keine)
	CString		    m_aComboTxt  [MAX_COMBO];					// Text (Variabelname oder '---') in den ComboBox'en
	CString		    m_aUnitName  [MAX_VAR];						// Namen der Einheiten bei den Variablen ".... [X]"
	CString		    m_aVarName   [MAX_VAR];						// Namen der Variablen "xxxx [...]"
	COLORREF	    m_aVarColor  [MAX_VAR];						// Sind die Farben der Variablen
	double			m_aVarMin    [MAX_VAR];						// Untere Grenze fr die Variable
	double			m_aVarMax    [MAX_VAR];						// Obere Grenze fr die Variable
	double			m_aVarValue  [MAX_VAR];						// Aktueller Wert der Variable
	double		    m_aUnitScale [MAX_VAR];						// Ist die Skalierung fr die Einheit
	UINT		    m_aVarError  [MAX_VAR];						// 0=keine 1=keine Var 2=reserviert 3=doppelt
	BOOL			m_aVarMinOk  [MAX_VAR];						// Ist der Min-Wert ok
	BOOL			m_aVarMaxOk  [MAX_VAR];						// Ist der Max-Wert ok
	BOOL			m_aVarValueOk[MAX_VAR];						// Ist der Variabel-Wert ok
	BOOL			m_aVarSet    [MAX_VAR];						// Ist die Variabel als Vorgabe markiert
	BOOL			m_aVarIntern [MAX_VAR];						// Ist die Variabel im Listenfenster definiert
	BOOL		    m_aMinMaxErr [MAX_VAR];						// Gibt es Fehler beim Min/Max-Bereich
	BYTE		    m_aVarScala  [MAX_VAR];						// 0=linear anzeigen  1=loarithmisch anzeigen
	BYTE		    m_aVarMark   [MAX_VAR];						// Welche Marke (0=keine 1=X 2=Y1 3=Y2 4=Y3)
	BYTE			m_aVarType	 [MAX_VAR];						// Ist der ermittelte Typ der Variabel (siehe TYPE_???)
	INT			    m_aVarEqation[MAX_VAR];						// Welche Formel berechnet die Variable (-1 keine)
	UINT			m_aOutIndex[3];								// Index der Y1/Y2/Y3/Z Ergebnisvariablen
	UINT			m_aInpIndex[2];								// Index der X/Y Laufvariablen
	
	BitSet			m_uVarList;									// Variablen die im Listenfenster stehen
	BitSet			m_uVarFixed;								// Variablen die via ComboBox fixiert sind oder im Listenfenster als Vorgabe
	BitSet			m_uVarCombo;								// Variablen die via ComboBox fixiert sind als Vorgabe
	BitSet			m_uVarInput;								// Laufvariablen die (X/Y) aus dem Listenfenster
	BitSet			m_uVarOutput;								// Ergebnis die (Z,Y1,Y2,Y3) aus dem Listenfenster
	BitSet			m_uVarResult;								// Variablen fr die es eine Formel gibt
	BitSet			m_uVarConst;								// Variablen fr die Konstant sind
	BitSet 		    m_uVarMask;									// Maske fr alle Varaiablen

	CString			m_sTempTextX;								// X -Text fr 2 auf 3 Linienwechsel
	CString			m_sTempTextY3;								// Y3-Text fr 2 auf 3 Linienwechsel
	CString			m_sEquErrText;								// Untertext fr Fehler bei Formeln
	UINT			m_uEquUpdate;								// Ticker fr Formel-Update
	UINT			m_uEquCount;								// Anzahl der benutzten Variablen
	UINT			m_uEquListCnt;								// Anzahl der Rechenwege
	UINT			m_uEquErrors;								// Fehlernummer bei den Formeln
	
	CString		    m_aEquFull   [MAX_EQU];						// Ist der Text der Formel mit Ergbnis
	CString		    m_aEquations [MAX_EQU];						// Text der Formeln ohne Ergbnis
	CString		    m_aEquResult [MAX_EQU];						// Namen der Ergebnisvaraiblen
	INT				m_aEquResVar [MAX_EQU];						// Position des Ergebnisses in m_aVarName (-1=nicht enthalten)
	BitSet 		    m_aEquDepend [MAX_EQU];						// Bitfeld fr Variabelabhngigkeiten
	CalcGenData		m_aEquGens	 [MAX_EQU];						// Rechner fr Formeln
	BYTE			m_aEquPost	 [MAX_EQU];						// Liste mit ab zu arbeiteten Formeln am Ende (0xFF=Ende)
	BYTE			m_aEquConst	 [MAX_EQU];						// Liste mit ab zu arbeiteten konstanten Formel (0xFF=Ende)
	BYTE			m_aEquList	 [MAX_EQU];						// Liste mit ab zu arbeiteten Formel (0xFF=Ende)
	
	UINT			m_uOptionsOld;								// Optionen fr 2D alt
	UINT			m_uOptions2D;								// Optionen fr 2D
	UINT			m_uOptions3D;								// Optionen fr 3D
	PlaneParams		m_sParams3D;								// Parameter fr 3D

	double			m_aDrawValues  [MAX_VAR+3];					// Min-Max-Werte fr's Zeichen
	CalcGenData		m_aDrawEqu	   [MAX_EQU];					// Rechner fr Formeln fr's Zeichen
	INT				m_aDrawEquVar  [MAX_EQU];					// Variabel-Position der Ergebnisse
	BYTE			m_aDrawEquList [MAX_EQU];					// Liste mit ab zu arbeiteten Formeln (0xFF=Ende)
	BYTE			m_aPostEquList [MAX_EQU];					// Liste mit Formeln frs Ende (0xFF=Ende)
	BYTE			m_aConstEquList[MAX_EQU];					// Liste mit konstanten Formeln (0xFF=Ende)
	CalcGenData		m_aPostEqu	   [MAX_EQU];					// Rechner fr Formeln am Ende
	CalcGenData		m_aConstEqu	   [MAX_EQU];					// Rechner fr konstande Formeln
	CSemaphore		m_sDrawUpdate;								// Semaphore fr Formel-Update
	CSemaphore		m_sDrawLocker;								// Semaphore fr das Zeichen
	CSemaphoreEx	m_sDrawTicker;								// Warte Semaphore fr Zeichen-Thread
	UINT volatile	m_uConstEquCnt;								// Anzahl der konstanten Formeln 
	UINT volatile	m_uPostEquCnt;								// Anzahl der benutzten Formeln danach
	UINT volatile	m_uDrawEquCnt;								// Anzahl der benutzten Formeln
	UINT volatile	m_uDrawVarCnt;								// Anzahl der benutzten Formeln
	BOOL volatile	m_bDrawRunning;								// Luft der Zeichen-Thread
	BOOL volatile	m_bDrawStop;								// Zeichen-Thread anhalten
	BOOL volatile	m_bDrawLock;								// Es wird gerade gezeichned
	BOOL volatile	m_bDrawStart;								// Das Zeichnen neu starten
	BOOL volatile	m_bDrawReinit;								// Die Formeln neu holen
	BOOL volatile	m_bDraw2D;									// In 2D zeichnen
	double		   *m_pDrawResults;								// Speicher fr Berechnungen
	int 			m_iDrawResCnt;								// Gres des Berechnungsspeichers

	int				m_iXorMode;									// Art der XOR-Linien (0=aus 1=2D 2=3D)
	int				m_iXorOn;									// Sind die Linien an
	int				m_aXorX[8];									// Position der Linien
	int				m_aXorY[8];									//		*
	CPoint			m_sXorPoint;								// Letzte Cursor-Position
	double			m_dXorValue[MAX_VAR];								// X/Y/Z Werte vor XOR

	//{{AFX_MSG(CMathViewerDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg HBRUSH	OnCtlColor(CDC *pDC,CWnd *pWnd,UINT nCtlColor);
	virtual void OnCancel();
	virtual void OnOK();
	afx_msg void OnSave();
	afx_msg void OnLoad();
	afx_msg void OnClick();
	afx_msg void OnChange();
	afx_msg void OnRedraw();
	afx_msg void OnDestroy();
	afx_msg void OnTimer(UINT_PTR uIdEvent);
	afx_msg void OnSize(UINT nType,int iSizeX,int iSizeY);
	afx_msg void OnSizing(UINT nSide,LPRECT pRect);
	afx_msg void OnHScroll(UINT nSBCode,UINT nPos,CScrollBar *pScrollBar);
	afx_msg void OnChangeComboxX();
	afx_msg void OnChangeComboxY();
	afx_msg void OnChangeComboxZ();
	afx_msg void OnChangeCombox1();
	afx_msg void OnChangeCombox2();
	afx_msg void OnChangeCombox3();
	afx_msg void OnChangeCombox4();
	afx_msg void OnChangeCombox5();
	afx_msg void OnOptionChanged();
	afx_msg void OnValueChanged();
	afx_msg void OnOptions();
	afx_msg void OnPicture();
	//}}AFX_MSG

	afx_msg void OnChangeNotify(NMHDR *pNmHdr,LRESULT *pResult);
	afx_msg void OnListEndEdit (NMHDR *pNmHdr,LRESULT *pResult);
	afx_msg void OnItemsMoved  (NMHDR *pNmHdr,LRESULT *pResult);
	afx_msg void OnVarUpdate();
	afx_msg void OnHelp();

	void	OnChangeCombox(int iSlider);
	void	SaveRegistry();
	void	Draw2D(BitmapImage *pImage=0);
	void	Draw3D(BitmapImage *pImage=0);
	void	ChangeLines();
	int		UpdateList();
	int		UpdateErros();
	int		UpdateValues();
	int		UpdateEquations();
	int  	UpdateSliders (int iSlider=-1);
	void	UpdateConst   (UINT uRow);
	int		UpdateUnit    (UINT uRow,LPCTSTR pText=0);
	int 	CalcValues    (double *pValues,BitSet uIgnore=0);
	double	GetValue      (UINT uRow,UINT    uCol=1,int iScale=1);
	void 	SetValue      (double dValue,UINT uRow,UINT uCol=1,int iScale=1);
	int		CheckConst    (BitSet uNeed,BitSet uLock,BitSet uConst,BitSet &uUsed);
	int		Load	      (LPCSTR pPath,BOOL bObtions=FALSE);
	int		UpdateCalculator();
	int 	DoStore		  ();

	static	UINT		DrawProc(LPVOID pParam);
			UINT		DrawProc();
	static	int _cdecl	TokenCallback(void *pParam,const char *pText, double *pValue,unsigned *pVarNumber);
			int         TokenCallback(             const char *pText, double *pValue,unsigned *pVarNumber);

	static	void		DrawCallback (void *pParam,CDC *pDc,PAINTSTRUCT *pPaint);
			void		DrawCallback (             CDC *pDc,PAINTSTRUCT *pPaint);
	static	void		MouseCallback(void *pParam,UINT uType,UINT nFlags,CPoint sPoint);
			void		MouseCallback(             UINT uType,UINT nFlags,CPoint sPoint);


	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}

#endif

