//*****************************************************************************
//*
//*
//*		OptionenDlg.cpp
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"MathViewer.h"
#include	"OptionenDlg.h"

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

BEGIN_MESSAGE_MAP(COptionenDlg, CDialog)
	//{{AFX_MSG_MAP(COptionenDlg)
	ON_WM_TIMER()
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_DEFAULT, OnDefault)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

DLG_OLDPOS(COptionenDlg)

typedef struct
	{
	UINT	uControl;
	UINT	uOffset;	
	UINT	uMask;
	}IdItem;

#define 	ENTRIES(a)		(sizeof(a)/sizeof((a)[0]))
#define 	UINTPTR(a)		(unsigned*)(((char*)this)+a)


static IdItem	aIds[] =
	{
	IDC_CHECK11,	offsetof(COptionenDlg,m_uOptions2D),	CDR_DOUBLE,
	IDC_CHECK12,	offsetof(COptionenDlg,m_uOptions2D),	CDR_GRID_X,
	IDC_CHECK13,	offsetof(COptionenDlg,m_uOptions2D),	CDR_GRID_Y,
	IDC_CHECK14,	offsetof(COptionenDlg,m_uOptions2D),	CDR_3LINES,
	IDC_CHECK15,	offsetof(COptionenDlg,m_uOptions2D),	CDR_SHADOW,
	IDC_CHECK16,	offsetof(COptionenDlg,m_uOptions2D),	CDR_FILL_1,
	IDC_CHECK17,	offsetof(COptionenDlg,m_uOptions2D),	CDR_FILL_2,
	IDC_CHECK18,	offsetof(COptionenDlg,m_uOptions2D),	CDR_FILL_3,
	IDC_CHECK19,	offsetof(COptionenDlg,m_uOptions2D),	CDR_SCALA_X,
	IDC_CHECK20,	offsetof(COptionenDlg,m_uOptions2D),	CDR_SCALA_1,
	IDC_CHECK21,	offsetof(COptionenDlg,m_uOptions2D),	CDR_SCALA_2,
	IDC_CHECK22,	offsetof(COptionenDlg,m_uOptions2D),	CDR_SCALA_3,
	IDC_CHECK51,	offsetof(COptionenDlg,m_uOptions3D),	PDR_DOUBLE,
	IDC_CHECK52,	offsetof(COptionenDlg,m_uOptions3D),	PDR_QUARD,
	IDC_CHECK53,	offsetof(COptionenDlg,m_uOptions3D),	PDR_GRID,
	IDC_CHECK54,	offsetof(COptionenDlg,m_uOptions3D),	PDR_PLANE,
	IDC_CHECK55,	offsetof(COptionenDlg,m_uOptions3D),	PDR_LIGHT,
	IDC_CHECK56,	offsetof(COptionenDlg,m_uOptions3D),	PDR_SCALA_X,
	IDC_CHECK57,	offsetof(COptionenDlg,m_uOptions3D),	PDR_SCALA_Y,
	IDC_CHECK58,	offsetof(COptionenDlg,m_uOptions3D),	PDR_SCALA_Z,
	IDC_CHECK59,	offsetof(COptionenDlg,m_uOptions3D),	PDR_COLORBAR,
	IDC_CHECK60,	offsetof(COptionenDlg,m_uOptions3D),	PDR_TEXT_X,
	IDC_CHECK61,	offsetof(COptionenDlg,m_uOptions3D),	PDR_TEXT_Y,
	IDC_CHECK62,	offsetof(COptionenDlg,m_uOptions3D),	PDR_TEXT_Z,
	IDC_CHECK63,	offsetof(COptionenDlg,m_uOptions3D),	PDR_COLORFIELD,
	IDC_CHECK64,	offsetof(COptionenDlg,m_uOptions3D),	PDR_GRIDDOUBLE,
	};

//*****************************************************************************
//*
//*		CDialog
//*
//*****************************************************************************
//  COptionenDlg Dialog
COptionenDlg::COptionenDlg(CWnd *pParent): CDialog(COptionenDlg::IDD,pParent)
{
	//{{AFX_DATA_INIT(COptionenDlg)
	m_iShadowMode	=  2;
	m_sShadowPos	=  _T("0.0");
	//}}AFX_DATA_INIT

	m_bIsD2			= 0;
	m_pOptions2D	= 0;
	m_pOptions3D	= 0;
	m_pParams3D		= 0;
	m_pOptions2D	= 0;
	m_pOptions3D	= 0;
	memset(&m_sParams3D,0,sizeof(m_sParams3D));

}

//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void COptionenDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptionenDlg)
	DDX_Radio (pDX,IDC_RADIO1 ,m_iShadowMode);
	DDX_Text  (pDX,IDC_EDIT1  ,m_sShadowPos );
	//}}AFX_DATA_MAP
}


//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
//  COptionenDlg message handlers
BOOL COptionenDlg::OnInitDialog()
{
CSliderCtrl *pSlider;
unsigned    *pPtr;
unsigned	 uPos;
CRegKeys	 sKey;

	
	
	sKey.Open(HKEY_CURRENT_USER,"Software\\AZ\\MathViewer\\OptionDlg");
	LOAD_DLG_OLDPOS(sKey,"OldScreen");


	if(m_pOptions2D)m_uOptions2D=*m_pOptions2D;
	if(m_pOptions3D)m_uOptions3D=*m_pOptions3D;
	if(m_pParams3D )m_sParams3D =*m_pParams3D;
	
	m_uOldOptions2D	= m_uOptions2D;
	m_uOldOptions3D	= m_uOptions3D;
	m_sOldParams3D	= m_sParams3D;

	m_uChgOptions2D	= m_uOptions2D;
	m_uChgOptions3D	= m_uOptions3D;
	m_sChgParams3D	= m_sParams3D;
	
	m_uTicker		= 0;

	m_iShadowMode	=(m_uOptions3D&PDR_SHADOW)? m_sParams3D.iShadowPlane+1:0;
	m_sShadowPos.Format("%g",m_sParams3D.dShadow);

	pSlider	= GetDlgSliderCtrl(IDC_SLIDER1);
	pSlider->SetRange(-45,45);
	pSlider->SetPageSize(10);
	pSlider->SetLineSize(5);
	pSlider->SetTicFreq(5);
	pSlider->SetPos((int)m_sParams3D.dRollX);

	pSlider	= GetDlgSliderCtrl(IDC_SLIDER2);
	pSlider->SetRange(-45,45);
	pSlider->SetPageSize(10);
	pSlider->SetLineSize(5);
	pSlider->SetTicFreq(5);
	pSlider->SetPos((int)m_sParams3D.dRollY);

	pSlider	= GetDlgSliderCtrl(IDC_SLIDER3);
	pSlider->SetRange(-45,45);
	pSlider->SetPageSize(10);
	pSlider->SetLineSize(5);
	pSlider->SetTicFreq(5);
	pSlider->SetPos((int)m_sParams3D.dRollZ);

	pSlider	= GetDlgSliderCtrl(IDC_SLIDER4);
	pSlider->SetRange(-45,45);
	pSlider->SetPageSize(10);
	pSlider->SetLineSize(5);
	pSlider->SetTicFreq(5);
	pSlider->SetPos((int)(m_sParams3D.dZoom*45.0));

	pSlider	= GetDlgSliderCtrl(IDC_SLIDER5);
	pSlider->SetRange(-45,45);
	pSlider->SetPageSize(10);
	pSlider->SetLineSize(5);
	pSlider->SetTicFreq(5);
	pSlider->SetPos((int)(m_sParams3D.dLook*45.0));

	
	for(uPos=0;uPos<ENTRIES(aIds);uPos++)
		{
		pPtr = UINTPTR(aIds[uPos].uOffset);
		GetDlgButton(aIds[uPos].uControl)->SetCheck((*pPtr&aIds[uPos].uMask)? 1:0);
		}

	CDialog::OnInitDialog();

	
	SetTimer(ID_OPTION_CHG,250,NULL);



return TRUE;
}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void COptionenDlg::OnCancel()
{
CRegKeys	sKey;
unsigned	uChg;



	UpdateData();


	if(m_bIsD2 && m_uOldOptions2D!=m_uOptions2D)
		{
		uChg = 1;
		}
	
	if(m_bIsD2==0 && (m_uOldOptions3D!=m_uOptions3D || memcmp(&m_sOldParams3D,&m_sParams3D,sizeof(m_sParams3D))))
		{
		uChg = 1;
		}

	m_uOptions2D	= m_uOldOptions2D;
	m_uOptions3D	= m_uOldOptions3D;
	m_sParams3D		= m_sOldParams3D;

	if(m_pOptions2D)*m_pOptions2D=m_uOptions2D;
	if(m_pOptions3D)*m_pOptions3D=m_uOptions3D;
	if(m_pParams3D )*m_pParams3D =m_sParams3D;

	
	sKey.Open(HKEY_CURRENT_USER,"Software\\AZ\\MathViewer\\OptionDlg");
	SAVE_DLG_OLDPOS(sKey,"OldScreen");
	
	if(uChg)
		{
		CDialog::OnOK();
		return;
		}
	

	CDialog::OnCancel();



}

//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void COptionenDlg::OnOK()
{
CRegKeys	 sKey;


	UpdateData();	
	UpdateValues();

	if(m_uOldOptions2D==m_uOptions2D && m_uOldOptions3D==m_uOptions3D &&
	  !memcmp(&m_sOldParams3D,&m_sParams3D,sizeof(m_sParams3D)))
		{
		OnCancel();
		}

	if(m_pOptions2D)*m_pOptions2D=m_uOptions2D;
	if(m_pOptions3D)*m_pOptions3D=m_uOptions3D;
	if(m_pParams3D )*m_pParams3D =m_sParams3D;

	sKey.Open(HKEY_CURRENT_USER,"Software\\AZ\\MathViewer\\OptionDlg");
	SAVE_DLG_OLDPOS(sKey,"OldScreen");

	CDialog::OnOK();
}

//*****************************************************************************
//*
//*		OnHScroll
//*
//*****************************************************************************
void COptionenDlg::OnHScroll(UINT nSBCode,UINT nPos,CScrollBar *pScrollBar)
{
CSliderCtrl	   *pSlider;
int				iPos;
int				iOld;



	if(pScrollBar==NULL)return;

	pSlider		= (CSliderCtrl*)pScrollBar;
	iPos		= pSlider->GetPos();
	iOld		= iPos;

	switch(nSBCode)
		{
	case SB_THUMBPOSITION:	iPos=nPos;	break;
	case SB_THUMBTRACK:		iPos=nPos;	break;
		}

			pSlider->SetPos(iPos);
	iPos =	pSlider->GetPos();

	if(!m_bIsD2)UpdateValues();
	

}

//*****************************************************************************
//*
//*		OnCommand
//*
//*****************************************************************************
BOOL COptionenDlg::OnCommand(WPARAM wParam,LPARAM lParam)
{
unsigned	uPos;


	if(HIWORD(wParam)==BN_CLICKED)
		{
		for(uPos=0;uPos<ENTRIES(aIds);uPos++)
			{
			if(aIds[uPos].uControl!=LOWORD(wParam))continue;
			UpdateValues();
			}

		if((IDC_RADIO1==LOWORD(wParam)) ||		
		   (IDC_RADIO2==LOWORD(wParam)) ||		
		   (IDC_RADIO3==LOWORD(wParam)) ||		
		   (IDC_RADIO4==LOWORD(wParam)))
			{
			UpdateValues();
			}
		}

	if(HIWORD(wParam)==EN_CHANGE)
	if(LOWORD(wParam)==IDC_EDIT1)
		{
		m_uTicker = 6;
		}


return CDialog::OnCommand(wParam,lParam);
}

//*****************************************************************************
//*
//*		UpdateValues
//*
//*****************************************************************************
void COptionenDlg::UpdateValues()
{
char		cText[64];
unsigned   *pPtr;
unsigned	uPos;
unsigned	uChg;


	     if(GetDlgButton(IDC_RADIO4)->GetCheck())m_iShadowMode=3;
	else if(GetDlgButton(IDC_RADIO3)->GetCheck())m_iShadowMode=2;
	else if(GetDlgButton(IDC_RADIO2)->GetCheck())m_iShadowMode=1;
	else										 m_iShadowMode=0;


	if(m_iShadowMode)
		{
		m_uOptions3D |=  PDR_SHADOW;
		m_sParams3D.iShadowPlane = m_iShadowMode-1;
		}
	else{
		m_uOptions3D &= ~PDR_SHADOW;
		m_sParams3D.iShadowPlane = 2;	
		}

	GetDlgItemText(IDC_EDIT1,cText,sizeof(cText));
	m_sParams3D.dShadow = strtof(cText);


	for(uPos=0;uPos<ENTRIES(aIds);uPos++)
		{
		pPtr = UINTPTR(aIds[uPos].uOffset);
		
		if(GetDlgButton(aIds[uPos].uControl)->GetCheck())
				*pPtr |=  aIds[uPos].uMask;
		else	*pPtr &= ~aIds[uPos].uMask;
		}


	m_sParams3D.dRollX	= (double)GetDlgSliderCtrl(IDC_SLIDER1)->GetPos();
	m_sParams3D.dRollY	= (double)GetDlgSliderCtrl(IDC_SLIDER2)->GetPos();
	m_sParams3D.dRollZ	= (double)GetDlgSliderCtrl(IDC_SLIDER3)->GetPos();
	m_sParams3D.dZoom	= (double)GetDlgSliderCtrl(IDC_SLIDER4)->GetPos()/45.0;
	m_sParams3D.dLook	= (double)GetDlgSliderCtrl(IDC_SLIDER5)->GetPos()/45.0;

	uChg = 0;
	
	if(m_bIsD2 && m_uChgOptions2D!=m_uOptions2D)
		{
		uChg = 1;
		}
	
	if(m_bIsD2==0 && (m_uChgOptions3D!=m_uOptions3D || memcmp(&m_sChgParams3D,&m_sParams3D,sizeof(m_sParams3D))))
		{
		uChg = 1;
		}

	if(uChg)
		{
		m_uChgOptions2D	= m_uOptions2D;
		m_uChgOptions3D	= m_uOptions3D;
		m_sChgParams3D	= m_sParams3D;

		if(m_pOptions2D)*m_pOptions2D=m_uOptions2D;
		if(m_pOptions3D)*m_pOptions3D=m_uOptions3D;
		if(m_pParams3D )*m_pParams3D=m_sParams3D;

		GetParent()->PostMessage(WM_COMMAND,ID_OPTION_CHG);
		}


}

//*****************************************************************************
//*
//*		OnTimer
//*
//*****************************************************************************
void COptionenDlg::OnTimer(UINT_PTR nIdEvent)
{

	if(nIdEvent==ID_OPTION_CHG)
		{
		if(m_uTicker)
			{
				m_uTicker--;
			if(!m_uTicker)UpdateValues();	
			}
		}

	CDialog::OnTimer(nIdEvent);
}

//*****************************************************************************
//*
//*		OnDefault
//*
//*****************************************************************************
void COptionenDlg::OnDefault() 
{
CSliderCtrl *pSlider;
unsigned    *pPtr;
unsigned	 uPos;


	m_uOptions2D	    = CDR_DOUBLE;
//	m_uOptions2D	   |= CDR_SHADOW;
//	m_uOptions2D	   |= CDR_HAS_Y2;
//	m_uOptions2D	   |= CDR_FILL_1;
//	m_uOptions2D	   |= CDR_FILL_2;
	m_uOptions2D	   |= CDR_GRID_X;
	m_uOptions2D	   |= CDR_GRID_Y;
	m_uOptions2D	   |= CDR_SCALA_X;
	m_uOptions2D	   |= CDR_SCALA_1;
	m_uOptions2D	   |= CDR_SCALA_2;

	m_uOptions3D		= PDR_DOUBLE;
//	m_uOptions3D	   |= PDR_QUARD;
	m_uOptions3D	   |= PDR_GRID;
	m_uOptions3D	   |= PDR_PLANE;
//	m_uOptions3D	   |= PDR_SHADOW;
//	m_uOptions3D	   |= PDR_COLORFIELD;
	m_uOptions3D	   |= PDR_COLORBAR;
	m_uOptions3D	   |= PDR_LIGHT;
	m_uOptions3D	   |= PDR_TEXT_X;
	m_uOptions3D	   |= PDR_TEXT_Y;
	m_uOptions3D	   |= PDR_TEXT_Z;
	m_uOptions3D	   |= PDR_SCALA_X;
	m_uOptions3D	   |= PDR_SCALA_Y;
	m_uOptions3D	   |= PDR_SCALA_Z;

	m_sParams3D.dLook			=  0.0;
	m_sParams3D.dZoom			=  0.0;
	m_sParams3D.dRollX			=  0.0;
	m_sParams3D.dRollY			=  0.0;
	m_sParams3D.dRollZ			= 36.0;
	m_sParams3D.dShadow			=  0.0;
	m_sParams3D.iShadowPlane	=  2;

	m_iShadowMode	=(m_uOptions3D&PDR_SHADOW)? m_sParams3D.iShadowPlane+1:0;
	m_sShadowPos.Format("%g",m_sParams3D.dShadow);

	pSlider	= GetDlgSliderCtrl(IDC_SLIDER1);
	pSlider->SetPos((int)m_sParams3D.dRollX);

	pSlider	= GetDlgSliderCtrl(IDC_SLIDER2);
	pSlider->SetPos((int)m_sParams3D.dRollY);

	pSlider	= GetDlgSliderCtrl(IDC_SLIDER3);
	pSlider->SetPos((int)m_sParams3D.dRollZ);

	pSlider	= GetDlgSliderCtrl(IDC_SLIDER4);
	pSlider->SetPos((int)(m_sParams3D.dZoom*45.0));

	pSlider	= GetDlgSliderCtrl(IDC_SLIDER5);
	pSlider->SetPos((int)(m_sParams3D.dLook*45.0));

	
	for(uPos=0;uPos<ENTRIES(aIds);uPos++)
		{
		pPtr = UINTPTR(aIds[uPos].uOffset);
		GetDlgButton(aIds[uPos].uControl)->SetCheck((*pPtr&aIds[uPos].uMask)? 1:0);
		}

	UpdateValues();	
	
}
