//*****************************************************************************
//*
//*
//*		PictureDlg.cpp
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"MathViewer.h"
#include	"PictureDlg.h"

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

BEGIN_MESSAGE_MAP(CPictureDlg, CDialog)
	//{{AFX_MSG_MAP(CPictureDlg)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON1, OnPath)
	ON_BN_CLICKED(IDC_CHECK1,  OnCheck)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//*****************************************************************************
//*
//*		CDialog
//*
//*****************************************************************************
//  Dialogfeld CPictureDlg
CPictureDlg::CPictureDlg(CWnd *pParent/*=NULL*/): CDialog(CPictureDlg::IDD,pParent)
{
	//{{AFX_DATA_INIT(CPictureDlg)
	m_sSizeX	= _T("");
	m_sSizeY	= _T("");
	m_sPath 	= _T("");
	m_bClipBoard= FALSE;
	//}}AFX_DATA_INIT

	m_uSizeX	= 1024;
	m_uSizeY	= 768;
}


//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CPictureDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPictureDlg)
	DDX_Text    (pDX,IDC_EDIT1 ,m_sSizeX);
	DDX_Text    (pDX,IDC_EDIT2 ,m_sSizeY);
	DDX_CBString(pDX,IDC_COMBO1,m_sPath );
	DDX_Check(pDX, IDC_CHECK1, m_bClipBoard);
	//}}AFX_DATA_MAP
}


//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
//  Behandlungsroutinen fr Nachrichten CPictureDlg
BOOL CPictureDlg::OnInitDialog()
{
CRegKeys	sKey;


	 SetButtonBitmap(this,IDC_BUTTON1,IDB_OPEN);

	sKey.Open(HKEY_CURRENT_USER,"Software\\AZ\\MathViewer\\Picture");
	sKey.Get (m_uSizeX		,"SizeX"	    );
	sKey.Get (m_uSizeY		,"SizeY"	    );
	sKey.Get (m_sPath		,"Path"		    );
	sKey.Get (m_bClipBoard	,"ClipBoard"	);

	m_sSizeX.Format("%i",m_uSizeX);
	m_sSizeY.Format("%i",m_uSizeY);

	ComboBoxLoad(this,IDC_COMBO1,"NameList","Software\\AZ\\MathViewer\\Picture"); 


	CDialog::OnInitDialog();


	OnCheck();


return TRUE; 
}

//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CPictureDlg::OnDestroy()
{
	
	DelButtonBitmap(this,IDC_BUTTON1);
	
	CDialog::OnDestroy();

}

//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void CPictureDlg::OnOK()
{
CRegKeys	sKey;

	
	
	UpdateData();

	m_uSizeX = strtoi(m_sSizeX);
	m_uSizeY = strtoi(m_sSizeY);

	if(m_uSizeX>4096)m_uSizeX=4096;
	if(m_uSizeY>4096)m_uSizeY=4096;


	sKey.Open(HKEY_CURRENT_USER,"Software\\AZ\\MathViewer\\Picture");
	sKey.Set (m_uSizeX		,"SizeX"	    );
	sKey.Set (m_uSizeY		,"SizeY"	    );
	sKey.Set (m_sPath		,"Path"		    );
	sKey.Set (m_bClipBoard	,"ClipBoard"	);


	ComboBoxSave(this,IDC_COMBO1,"NameList","Software\\AZ\\MathViewer\\Picture"); 


	CDialog::OnOK();
}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void CPictureDlg::OnCancel()
{

	CDialog::OnCancel();
}

//*****************************************************************************
//*
//*		OnPath
//*
//*****************************************************************************
void CPictureDlg::OnPath()
{
CString			sPath;


	CFileDialog	sDlg(FALSE,_T("*.bmp;*.jpeg;*.jpg;*.png;*.xpm;*.tif;*.tiff;*.xwd;*.pnm"),m_sPath,OFN_EXPLORER|OFN_ENABLESIZING|OFN_PATHMUSTEXIST|OFN_HIDEREADONLY,"Bilddateien |*.bmp;*.jpeg;*.jpg;*.png;*.xpm;*.tif;*.tiff;*.xwd;*.pnm|Alle Dateien      (*.*)|*.*|");
	
	if(sDlg.DoModal()!=IDOK)return;

	m_sPath = sDlg.GetPathName();

	UpdateData(FALSE);
	ComboBoxInsert(this,IDC_COMBO1,m_sPath);

}


//*****************************************************************************
//*
//*		OnCheck
//*
//*****************************************************************************
void CPictureDlg::OnCheck()
{
	
	UpdateData();

	GetDlgItem(IDC_BUTTON1)->EnableWindow(!m_bClipBoard);
	GetDlgItem(IDC_COMBO1 )->EnableWindow(!m_bClipBoard);

	
}

